/*
#define IDH_extra 2
#define IDH_newmap 3
#define IDH_newsector 4
#define IDH_newwall 7
#define IDH_owner 1
#define IDH_paralax 5
#define IDH_sloped 6
//*/
///*
/*
#include <algorithm>
#include <vector>
#include <iterator>
using namespace std;
template<class Arg>
struct all_true : public unary_function<Arg, bool>
{
bool operator()(const Arg& x){ return 1; }
};
*/
#include "defines.h"
#include "cube.h"
#include <mem.h>
#include <stdio.h>
#include <dir.h>
#include <process.h>
#include <windows.h>
#include <commctrl.h>
#include <float.h>
#include <GL/gl.h>
#include "test.h"
#define DLG_DELETEITEM 1
#define DLG_TEST 3
#define GETDIRLISTING DlgDirList(hwndDlg,"*.map",ID_LOADNAME,0,DDL_ARCHIVE|DDL_DIRECTORY);
#define OPTIMIZED_WINDOW IS_ON
char info_enable=0;
char auto_update=0;
char first_load=1;
char szFile[260]; // buffer for filename
#if (processor_type == 586)
#pragma message ("OpenGL Build Touch Version 1.9.1 -  James Ferry 1999")
char *windowName = "OpenGL Build Touch Version 1.9.1 -  James Ferry 1999";
#elif (processor_type == 486)
#pragma message ("OpenGL Build Touch Version 1.9.1 -  James Ferry 1999 - i486 version")
char *windowName = "OpenGL Build Touch Version 1.9.1 -  James Ferry 1999 - i486 version";
#else
char *windowName = "OpenGL Build Touch Version 1.9.1 -  James Ferry 1999";
#endif
#ifdef OPTIMIZED_WINDOW
#define ViewWallBox glViewport(500, 500, 200, 200);
#define RightView glViewport(500, 0, 200, 500);
#define FrontView glViewport(0, 0, 500, 500);
#define TopView glViewport(0, 500, 500, 200);
#define GLVIEWPORT3D glViewport(0, 0, 700, 700);
#else
#define ViewWallBox glViewport(700, 500, 200, 200);
#define RightView glViewport(700, 0, 200, 500);
#define FrontView glViewport(200, 0, 500, 500);
#define TopView glViewport(200, 500, 500, 200);
#define GLVIEWPORT3D glViewport(200, 0, 700, 700);
#endif
//char *old_dir;
int CURSECT=0;
int CURSPRITE=0;
int CURWALL=0;
HWND hWnd;
RECT rect;
char Redraw_all=0;
char show_one_side3d=0;
char show_wall3d=0;
#ifdef FLOATING_POINT
#define VERTEXxy glVertex2f(x,y);
#else
#define VERTEXxy glVertex2i(x,y);
#endif
#define BLACK_INDEX 0
#define RED_INDEX 13
#define GREEN_INDEX 14
#define YELLOW_INDEX 15
#define WHITE_INDEX 9
#define BLUE_INDEX 16
float latinc=0.0F,longinc=0.0F;
long mapversion,posx,posy,posz;
int ang, cursectnum;
int numsectors,numwalls,numsprites;
//long ceiling, floor;
typedef struct
{
short wallptr, wallnum;
long ceilingz, floorz;
short ceilingstat, floorstat;
short ceilingpicnum, ceilingheinum;
signed char ceilingshade;
char ceilingpal, ceilingxpanning, ceilingypanning;
short floorpicnum, floorheinum;
signed char floorshade;
char floorpal, floorxpanning, floorypanning;
char visibility, filler;
short lotag, hitag, extra;
} sectortype;
sectortype sector[1024];
typedef struct
{
long x, y;
short point2, nextwall, nextsector, cstat;
short picnum, overpicnum;
signed char shade;
char pal, xrepeat, yrepeat, xpanning, ypanning;
short lotag, hitag, extra;
} walltype;
walltype wall[8192];
typedef struct
{
long x, y, z;
// short cstat, picnum;
unsigned short cstat, picnum;
signed char shade;
char pal, clipdist, filler;
unsigned char xrepeat, yrepeat;
signed char xoffset, yoffset;
short sectnum, statnum;
short ang, owner, xvel, yvel, zvel;
short lotag, hitag, extra;
} spritetype;
spritetype sprite[4096];
int a;
HINSTANCE hinst;
PAINTSTRUCT ps;
char *className = "OpenGL Build Touch by James Ferry";
char *classMenu = "OpenGLBT";
int winX = 0, winY = 0;
int minX = 0, minY = 0;
#ifdef OPTIMIZED_WINDOW
int maxX = 700, maxY = 700;
#else
int maxX = 900, maxY = 700;
#endif
HDC hDC;
HGLRC hGLRC;
HPALETTE hPalette;
void
init(void)
{
/* set viewing projection */
glMatrixMode(GL_PROJECTION);
glFrustum(-100.0F, 100.0F, -100.0F, 100.0F, 100.0F, 800.0F);
/* position viewer */
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, -500.0F);
}
void
redraw3d(void)
{
register int a,b,c,e;
register int x,y,z;
glMatrixMode(GL_MODELVIEW);
glRotatef(-45.0F,1.0F,0.0F,0.0F);
glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
// glIndexi(RED_INDEX);
// #define BLUE_COLOUR glColor3b(0,0,0);
// BLUE_COLOUR
glIndexi(BLUE_INDEX);
glColor3b(0,0,0);
GLVIEWPORT3D
for(a=0;a<numsectors;a++){
c=sector[a].wallnum;
e=sector[a].wallptr;
glBegin(GL_LINE_LOOP);
for(b=0;b<c;b++)
{
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[a].ceilingz/500;
e=wall[e].point2;
glVertex3i(x,y,z);
}
glEnd();
glBegin(GL_LINE_LOOP);
for(b=0;b<c;b++)
{
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[a].floorz/500;
e=wall[e].point2;
glVertex3i(x,y,z);
}
glEnd();
}
if(show_wall3d)
{
for(a=0;a<numsectors;a++){
c=sector[a].wallnum;
e=sector[a].wallptr;
for(b=0;b<c;b++)
{
glBegin(GL_LINES);
if(wall[e].nextsector==-1&&wall[wall[e].point2].nextsector==-1)
{
if(show_one_side3d)
{
x=wall[wall[e].point2].x/250;
y=-wall[wall[e].point2].y/250;
z=-sector[a].ceilingz/500;
glVertex3i(x,y,z);
x=wall[wall[e].point2].x/250;
y=-wall[wall[e].point2].y/250;
z=-sector[a].floorz/500;
glVertex3i(x,y,z);
}}
else
{
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[a].floorz/500;
glVertex3i(x,y,z);
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[wall[e].nextsector].floorz/500;
glVertex3i(x,y,z);
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[a].ceilingz/500;
glVertex3i(x,y,z);
x=wall[e].x/250;
y=-wall[e].y/250;
z=-sector[wall[e].nextsector].ceilingz/500;
glVertex3i(x,y,z);
}
glEnd();
e=wall[e].point2;
}
}
}
SwapBuffers(hDC);
glMatrixMode(GL_MODELVIEW);
glRotatef(45.0F,1.0F,0.0F,0.0F);
}
void Right(void)
{
register int a,b,c,e;
#ifdef FLOATING_POINT
register float x,y;
#else
register int x,y;
#endif
RightView
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, 400.0F);
glIndexi(BLACK_INDEX);
glColor3b(0,0,0);
glBegin(GL_QUADS);
glVertex2i(-100,-100);
glVertex2i(100,-100);
glVertex2i(100,100);
glVertex2i(-100,100);
glEnd();
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, -400.0F);
glIndexi(BLUE_INDEX);
glColor3b(0,0,255);
for(a=0;a<numsectors;a++){
c=sector[a].wallnum;
e=sector[a].wallptr;
for(b=0;b<c;b++)
{
glBegin(GL_LINE_STRIP);
y=-wall[wall[e].point2].y/100+latinc;
x=-sector[a].ceilingz/500;
VERTEXxy
y=-wall[e].y/100+latinc;
x=-sector[a].ceilingz/500;
VERTEXxy
y=-wall[e].y/100+latinc;
x=-sector[a].floorz/500;
VERTEXxy
y=-wall[wall[e].point2].y/100+latinc;
x=-sector[a].floorz/500;
VERTEXxy
e=wall[e].point2;
glEnd();
}
}
glIndexi(WHITE_INDEX);
glColor3b(255,255,255);
glBegin(GL_LINES);
y=-sprite[CURSPRITE].y/100+latinc-2000;
x=-sprite[CURSPRITE].z/500;
VERTEXxy
y=-sprite[CURSPRITE].y/100+latinc+2000;
x=-sprite[CURSPRITE].z/500;
VERTEXxy
y=-sprite[CURSPRITE].y/100+latinc;
x=-sprite[CURSPRITE].z/500-2000;
VERTEXxy
y=-sprite[CURSPRITE].y/100+latinc;
x=-sprite[CURSPRITE].z/500+2000;
VERTEXxy
glEnd();
}
void Top(void)
{
register int a,b,c,e;
#ifdef FLOATING_POINT
register float x,y;
#else
register int x,y;
#endif
TopView
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, 400.0F);
glIndexi(BLACK_INDEX);
glColor3b(0,0,0);
glBegin(GL_QUADS);
glVertex2i(-100,-100);
glVertex2i(100,-100);
glVertex2i(100,100);
glVertex2i(-100,100);
glEnd();
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, -400.0F);
glIndexi(BLUE_INDEX);
glColor3b(0,0,255);
for(a=0;a<numsectors;a++){
c=sector[a].wallnum;
e=sector[a].wallptr;
for(b=0;b<c;b++)
{
glBegin(GL_LINE_STRIP);
x=wall[wall[e].point2].x/100-longinc;
y=-sector[a].ceilingz/500;
VERTEXxy
x=wall[e].x/100-longinc;
y=-sector[a].ceilingz/500;
VERTEXxy
x=wall[e].x/100-longinc;
y=-sector[a].floorz/500;
VERTEXxy
x=wall[wall[e].point2].x/100-longinc;
y=-sector[a].floorz/500;
VERTEXxy
glEnd();
e=wall[e].point2;
}
}
glIndexi(WHITE_INDEX);
glColor3b(255,255,255);
glBegin(GL_LINES);
x=sprite[CURSPRITE].x/100-longinc+2000;
y=-sprite[CURSPRITE].z/500;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc-2000;
y=-sprite[CURSPRITE].z/500;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc;
y=-sprite[CURSPRITE].z/500+2000;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc;
y=-sprite[CURSPRITE].z/500-2000;
VERTEXxy
glEnd();
}
void Front(void)
{
register int a,b,c,e;
#ifdef FLOATING_POINT
register float x,y;
#else
register int x,y;
#endif
FrontView
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, 400.0F);
glIndexi(BLACK_INDEX);
glColor3b(0,0,0);
glBegin(GL_QUADS);
glVertex2i(-100,-100);
glVertex2i(100,-100);
glVertex2i(100,100);
glVertex2i(-100,100);
glEnd();
glMatrixMode(GL_MODELVIEW);
glTranslatef(0.0F, 0.0F, -400.0F);
glIndexi(BLUE_INDEX);
glColor3b(0,0,255);
for(a=0;a<numsectors;a++){
c=sector[a].wallnum;
e=sector[a].wallptr;
glBegin(GL_LINE_LOOP);
for(b=0;b<c;b++)
{
x=wall[e].x/100-longinc;
y=-wall[e].y/100+latinc;
e=wall[e].point2;
VERTEXxy
/*#ifdef FLOATING_POINT
#define VERTEX glVertex2f(x,y);
#else
#define VERTEX glVertex2i(x,y);
#endif
*/
}
glEnd();
}
glIndexi(WHITE_INDEX);
glColor3b(255,255,255);
glBegin(GL_LINES);
x=sprite[CURSPRITE].x/100-longinc+2000;
y=-sprite[CURSPRITE].y/100+latinc;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc-2000;
y=-sprite[CURSPRITE].y/100+latinc;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc;
y=-sprite[CURSPRITE].y/100+2000+latinc;
VERTEXxy
x=sprite[CURSPRITE].x/100-longinc;
y=-sprite[CURSPRITE].y/100-2000+latinc;
VERTEXxy
glEnd();
}
void FrontSingle(int index)
{
register int b,c,e;
#ifdef FLOATING_POINT
register float x,y;
#else
register int x,y;
#endif
FrontView
glIndexi(index);
c=sector[CURSECT].wallnum;
e=sector[CURSECT].wallptr;
glBegin(GL_LINE_LOOP);
for(b=0;b<c;b++)
{
x=wall[e].x/100-longinc;
y=-wall[e].y/100+latinc;
e=wall[e].point2;
VERTEXxy
}
glEnd();
}
void FrontWall(int index)
{
#ifdef FLOATING_POINT
register float x,y;
#else
register int x,y;
#endif
FrontView
glIndexi(index);
glBegin(GL_LINES);
x=wall[CURWALL].x/100-longinc;
y=-wall[CURWALL].y/100+latinc;
VERTEXxy
x=wall[wall[CURWALL].point2].x/100-longinc;
y=-wall[wall[CURWALL].point2].y/100+latinc;
VERTEXxy
glEnd();
}
void resize(void)
{
/* set viewport to cover the window */
// glViewport(0, 0, 700, 700);
// glViewport(0, 0, winWidth, winHeight);
GetClientRect( hWnd, &rect );
// glViewport(0, 0, rect.right, rect.bottom);
}
BOOL bSetupPixelFormat(HDC hdc)
{
PIXELFORMATDESCRIPTOR pfd, *ppfd;
int pixelformat;
ppfd = &pfd;
ppfd->nSize = sizeof (PIXELFORMATDESCRIPTOR);
ppfd->nVersion = 1;
ppfd->dwFlags = PFD_DRAW_TO_WINDOW | PFD_SUPPORT_OPENGL |
PFD_DOUBLEBUFFER;
ppfd->dwLayerMask = PFD_MAIN_PLANE;
ppfd->iPixelType = PFD_TYPE_COLORINDEX;
ppfd->cColorBits = 8;
ppfd->cDepthBits = 16;
ppfd->cAccumBits = 0;
ppfd->cStencilBits = 0;
if ( (pixelformat = ChoosePixelFormat(hdc, ppfd)) == 0 )
{MessageBox(NULL, "ChoosePixelFormat failed", "Error", MB_OK);return FALSE;}
if (SetPixelFormat(hdc, pixelformat, ppfd) == 0)
{MessageBox(NULL, "SetPixelFormat failed", "Error", MB_OK);return FALSE;}
return 1;
}
void
setupPalette(HDC hDC)
{
bSetupPixelFormat(hDC);
}
char szItemName[260];
char file[260];
int load(void)
{
FILE *fil;
if ((fil=fopen(szFile,"rb")) == NULL)
{
if(first_load)
{
first_load=0;
*strcat(szFile,".map");
if ((fil=fopen(szFile,"rb")) == NULL)
{
return 1;
}
}
else
{
MessageBox(WindowFromDC(hDC), "Cannot open input file.", "File Error While Loading",MB_OK|MB_ICONEXCLAMATION);
return 1;
}
}{
//Load map version number (current version is 7L)
fread(&mapversion,4,1,fil);
//Load starting position
fread(&posx,4,1,fil);
fread(&posy,4,1,fil);
fread(&posz,4,1,fil); //Note: Z coordinates are all shifted up 4
fread(&ang,2,1,fil); //All angles are from 0-2047, clockwise
fread(&cursectnum,2,1,fil); //Sector of starting point
//Load all sectors (see sector structure described below)
fread(&numsectors,2,1,fil);
fread(sector,sizeof (sectortype),numsectors,fil);
//Load all walls (see wall structure described below)
fread(&numwalls,2,1,fil);
fread(wall,sizeof (walltype),numwalls,fil);
//Load all sprites (see sprite structure described below)
fread(&numsprites,2,1,fil);
fread(sprite,sizeof (spritetype),numsprites,fil);
fclose(fil);
}
return 0;
}
void save(void)
{
FILE *fil;
// if ((fil=fopen(file,"wb")) == NULL)
if ((fil=fopen(szFile,"wb")) == NULL)
{
MessageBox(WindowFromDC(hDC), "Sorry, I cannot open that file.", "File Error While Saving",MB_OK);
}
else
{
fwrite(&mapversion,4,1,fil);
//Load starting position
fwrite(&posx,4,1,fil);
fwrite(&posy,4,1,fil);
fwrite(&posz,4,1,fil); //Note: Z coordinates are all shifted up 4
fwrite(&ang,2,1,fil); //All angles are from 0-2047, clockwise
fwrite(&cursectnum,2,1,fil); //Sector of starting point
//Load all sectors (see sector structure described below)
fwrite(&numsectors,2,1,fil);
fwrite(sector,sizeof (sectortype),numsectors,fil);
//Load all walls (see wall structure described below)
fwrite(&numwalls,2,1,fil);
fwrite(wall,sizeof (walltype),numwalls,fil);
//Load all sprites (see sprite structure described below)
fwrite(&numsprites,2,1,fil);
fwrite(sprite,sizeof (spritetype),numsprites,fil);
fclose(fil);
}
}
char callme=BST_CHECKED;
int szItemNum;
void SetupSectorProc(HWND hwndDlg)
{
/*if(filestatus==0)
{
sprintf(szItemName,"%c%s%c is currently loaded",34,file,34);
SetDlgItemText(hwndDlg,ID_MAPNAME,szItemName);
filestatus=1;
}
*/
char repstring[80];
char repstring2[80];
if(sector[CURSECT].lotag>=10000)
sprintf(repstring2,"Plays sound %i once",sector[CURSECT].lotag-10000);
sprintf(repstring,"Sector type - %s",
sector[CURSECT].lotag==0?"Normal":
sector[CURSECT].lotag==1?"Water - above surface":
sector[CURSECT].lotag==2?"Water - below surface":
sector[CURSECT].lotag==9?"Sliding Star Trek door":
sector[CURSECT].lotag==15?"Elevator transport":
sector[CURSECT].lotag==16?"Elevator platform down":
sector[CURSECT].lotag==17?"Elevator platform up":
sector[CURSECT].lotag==18?"Elevator down":
sector[CURSECT].lotag==19?"Elevator up":
sector[CURSECT].lotag==20?"Ceiling door":
sector[CURSECT].lotag==21?"Floor door":
sector[CURSECT].lotag==22?"Split door":
sector[CURSECT].lotag==23?"Swinging door":
sector[CURSECT].lotag==25?"Sliding door":
sector[CURSECT].lotag==26?"Split Star Trek door":
sector[CURSECT].lotag==27?"Bridge":
sector[CURSECT].lotag==28?"Drop floor":
sector[CURSECT].lotag==29?"Teeth floor":
sector[CURSECT].lotag==30?"Rotating and rising bridge":
sector[CURSECT].lotag==31?"Two way train":
sector[CURSECT].lotag==32767?"Secret room":
sector[CURSECT].lotag==-1?"End level":
sector[CURSECT].lotag>=10000?repstring2:
"Unknown"
);
SetDlgItemText(hwndDlg,IDC_SINFO,repstring);
SetDlgItemText(hwndDlg,IDC_SINFOBOX,
"\
1 - Water - above surface\r\n\
2 - Water - below surface\r\n\
9 - Sliding Star Trek door\r\n\
15 - Elevator transport (SE 17)\r\n\
16 - Elevator platform down\r\n\
17 - Elevator platform up\r\n\
18 - Elevator down\r\n\
19 - Elevator up\r\n\
20 - Ceiling door\r\n\
21 - Floor door\r\n\
22 - Split door\r\n\
23 - Swinging door\r\n\
25 - Sliding door\r\n\
26 - Split Star Trek door\r\n\
27 - Bridge (SE 21)\r\n\
28 - Drop floor (SE 21)\r\n\
29 - Teeth door (SE 22)\r\n\
30 - Rotating and rising bridge\r\n\
31 - Two way train\r\n\
10000+S - Plays sound S once\r\n\
32767 - Secret room\r\n\
65535 - End level");
sprintf(szItemName,"%li",posx);
SetDlgItemText(hwndDlg,IDP_X,szItemName);
sprintf(szItemName,"%li",posy);
SetDlgItemText(hwndDlg,IDP_Y,szItemName);
sprintf(szItemName,"%li",posz);
SetDlgItemText(hwndDlg,IDP_Z,szItemName);
SetDlgItemInt(hwndDlg,IDP_ANG,ang,TRUE);
SetDlgItemInt(hwndDlg,IDP_SECTOR,cursectnum,TRUE);
SetDlgItemInt(hwndDlg,ID_SECTORNUM,CURSECT,TRUE);
SetDlgItemInt(hwndDlg,ID_FIRSTWALL,sector[CURSECT].wallptr,TRUE);
SetDlgItemInt(hwndDlg,ID_NUMWALL,sector[CURSECT].wallnum,TRUE);
SetDlgItemInt(hwndDlg,ID_VIS,sector[CURSECT].visibility,TRUE);
SetDlgItemInt(hwndDlg,ID_LOTAG,sector[CURSECT].lotag,TRUE);
SetDlgItemInt(hwndDlg,ID_HITAG,sector[CURSECT].hitag,TRUE);
SetDlgItemInt(hwndDlg,ID_EXTRA,sector[CURSECT].extra,TRUE);
if(sector[CURSECT].floorstat&1)
CheckDlgButton(hwndDlg,ID_FPARALAX,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FPARALAX,BST_UNCHECKED);
if(sector[CURSECT].floorstat&2)
CheckDlgButton(hwndDlg,ID_FSLOPE,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FSLOPE,BST_UNCHECKED);
if(sector[CURSECT].floorstat&4)
CheckDlgButton(hwndDlg,ID_FSWAP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FSWAP,BST_UNCHECKED);
if(sector[CURSECT].floorstat&8)
CheckDlgButton(hwndDlg,ID_FSMOOTH,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FSMOOTH,BST_UNCHECKED);
if(sector[CURSECT].floorstat&16)
CheckDlgButton(hwndDlg,ID_FXFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FXFLIP,BST_UNCHECKED);
if(sector[CURSECT].floorstat&32)
CheckDlgButton(hwndDlg,ID_FYFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FYFLIP,BST_UNCHECKED);
if(sector[CURSECT].floorstat&64)
CheckDlgButton(hwndDlg,ID_FALIGN,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_FALIGN,BST_UNCHECKED);
sprintf(szItemName,"%li",sector[CURSECT].floorz);
SetDlgItemText(hwndDlg,ID_FZ,szItemName);
SetDlgItemInt(hwndDlg,ID_FHEINUM,sector[CURSECT].floorheinum,TRUE);
SetDlgItemInt(hwndDlg,ID_FPIC,sector[CURSECT].floorpicnum,TRUE);
SetDlgItemInt(hwndDlg,ID_FSHADE,sector[CURSECT].floorshade,TRUE);
SetDlgItemInt(hwndDlg,ID_FPAL,sector[CURSECT].floorpal,TRUE);
SetDlgItemInt(hwndDlg,ID_FX,sector[CURSECT].floorxpanning,TRUE);
SetDlgItemInt(hwndDlg,ID_FY,sector[CURSECT].floorypanning,TRUE);
if(sector[CURSECT].ceilingstat&1)
CheckDlgButton(hwndDlg,ID_CPARALAX,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CPARALAX,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&2)
CheckDlgButton(hwndDlg,ID_CSLOPE,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CSLOPE,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&4)
CheckDlgButton(hwndDlg,ID_CSWAP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CSWAP,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&8)
CheckDlgButton(hwndDlg,ID_CSMOOTH,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CSMOOTH,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&16)
CheckDlgButton(hwndDlg,ID_CXFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CXFLIP,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&32)
CheckDlgButton(hwndDlg,ID_CYFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CYFLIP,BST_UNCHECKED);
if(sector[CURSECT].ceilingstat&64)
CheckDlgButton(hwndDlg,ID_CALIGN,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_CALIGN,BST_UNCHECKED);
sprintf(szItemName,"%li",sector[CURSECT].ceilingz);
SetDlgItemText(hwndDlg,ID_CZ,szItemName);
SetDlgItemInt(hwndDlg,ID_CHEINUM,sector[CURSECT].ceilingheinum,TRUE);
SetDlgItemInt(hwndDlg,ID_CPIC,sector[CURSECT].ceilingpicnum,TRUE);
SetDlgItemInt(hwndDlg,ID_CSHADE,sector[CURSECT].ceilingshade,TRUE);
SetDlgItemInt(hwndDlg,ID_CPAL,sector[CURSECT].ceilingpal,TRUE);
SetDlgItemInt(hwndDlg,ID_CX,sector[CURSECT].ceilingxpanning,TRUE);
SetDlgItemInt(hwndDlg,ID_CY,sector[CURSECT].ceilingypanning,TRUE);
SetDlgItemInt(hwndDlg,ID_WNUM,CURWALL,TRUE);
SetDlgItemInt(hwndDlg,ID_WLOTAG,wall[CURWALL].lotag,TRUE);
SetDlgItemInt(hwndDlg,ID_WHITAG,wall[CURWALL].hitag,TRUE);
SetDlgItemInt(hwndDlg,ID_WEXTRA,wall[CURWALL].extra,TRUE);
if(wall[CURWALL].cstat&1)
CheckDlgButton(hwndDlg,ID_WBLOCKED,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WBLOCKED,BST_UNCHECKED);
if(wall[CURWALL].cstat&2)
CheckDlgButton(hwndDlg,ID_WSWAPPED,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WSWAPPED,BST_UNCHECKED);
if(wall[CURWALL].cstat&4)
CheckDlgButton(hwndDlg,ID_WALIGNED,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WALIGNED,BST_UNCHECKED);
if(wall[CURWALL].cstat&8)
CheckDlgButton(hwndDlg,ID_WXFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WXFLIP,BST_UNCHECKED);
if(wall[CURWALL].cstat&16)
CheckDlgButton(hwndDlg,ID_WMASKED,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WMASKED,BST_UNCHECKED);
if(wall[CURWALL].cstat&32)
CheckDlgButton(hwndDlg,ID_WONEWAY,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WONEWAY,BST_UNCHECKED);
if(wall[CURWALL].cstat&64)
CheckDlgButton(hwndDlg,ID_WHITSCAN,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WHITSCAN,BST_UNCHECKED);
if(wall[CURWALL].cstat&128)
CheckDlgButton(hwndDlg,ID_WTRANS,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WTRANS,BST_UNCHECKED);
if(wall[CURWALL].cstat&256)
CheckDlgButton(hwndDlg,ID_WYFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WYFLIP,BST_UNCHECKED);
if(wall[CURWALL].cstat&512)
CheckDlgButton(hwndDlg,ID_WREV,BST_CHECKED);
else
CheckDlgButton(hwndDlg,ID_WREV,BST_UNCHECKED);
sprintf(szItemName,"%li",wall[CURWALL].x);
SetDlgItemText(hwndDlg,ID_WX,szItemName);
sprintf(szItemName,"%li",wall[CURWALL].y);
SetDlgItemText(hwndDlg,ID_WY,szItemName);
SetDlgItemInt(hwndDlg,ID_WPOINT2,wall[CURWALL].point2,TRUE);
SetDlgItemInt(hwndDlg,ID_WNEXTW,wall[CURWALL].nextwall,TRUE);
SetDlgItemInt(hwndDlg,ID_WNEXTS,wall[CURWALL].nextsector,TRUE);
SetDlgItemInt(hwndDlg,ID_WPIC,wall[CURWALL].picnum,TRUE);
SetDlgItemInt(hwndDlg,ID_WOVERPIC,wall[CURWALL].overpicnum,TRUE);
SetDlgItemInt(hwndDlg,ID_WSHADE,wall[CURWALL].shade,TRUE);
SetDlgItemInt(hwndDlg,ID_WPAL,wall[CURWALL].pal,TRUE);
SetDlgItemInt(hwndDlg,ID_WXREP,wall[CURWALL].xrepeat,TRUE);
SetDlgItemInt(hwndDlg,ID_WYREP,wall[CURWALL].yrepeat,TRUE);
SetDlgItemInt(hwndDlg,ID_WXPAN,wall[CURWALL].xpanning,TRUE);
SetDlgItemInt(hwndDlg,ID_WYPAN,wall[CURWALL].ypanning,TRUE);
//DlgDirList(hwndDlg,"*.map",IDC_LISTBOX1,0,DDL_ARCHIVE);
}
void ReplaceProc(HWND hwndDlg)
{
int original_tile;
int new_tile;
int a;
int count[5]={0,0,0,0,0};
char repstring[80];
original_tile=GetDlgItemInt(hwndDlg,IDC_R_ORIGINAL,NULL,TRUE);
new_tile=GetDlgItemInt(hwndDlg,IDC_R_NEW,NULL,TRUE);
// HERE
if(IsDlgButtonChecked(hwndDlg,IDC_R_CEILINGS)==BST_CHECKED)
for(a=0;a<numsectors;a++)
if(sector[a].ceilingpicnum==original_tile)
{count[0]++;sector[a].ceilingpicnum=new_tile;}
if(IsDlgButtonChecked(hwndDlg,IDC_R_FLOORS)==BST_CHECKED)
for(a=0;a<numsectors;a++)
if(sector[a].floorpicnum==original_tile)
{count[1]++;sector[a].floorpicnum=new_tile;}
if(IsDlgButtonChecked(hwndDlg,IDC_R_WALLS)==BST_CHECKED)
for(a=0;a<numwalls;a++)
{
if(wall[a].picnum==original_tile)
{count[2]++;wall[a].picnum=new_tile;}
if(wall[a].overpicnum==original_tile)
{count[3]++;wall[a].overpicnum=new_tile;}
}
if(IsDlgButtonChecked(hwndDlg,IDC_R_SPRITES)==BST_CHECKED)
for(a=0;a<numsprites;a++)
if(sprite[a].picnum==original_tile)
{count[4]++;sprite[a].picnum=new_tile;}
sprintf(repstring,
"Converted \
%i ceilings, \
%i floors, \
%i walls, \
%i overwals,\nand \
%i sprites from image \
%i to image \
%i.",count[0],count[1],count[2],count[3],count[4],original_tile,new_tile);
MessageBox(NULL, repstring, "Completed", MB_OK);
}
BOOL CALLBACK ReplaceItemProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
/*
BOOL CALLBACK ReplaceItemProc(hwndDlg, message, wParam, lParam)
HWND hwndDlg;
UINT message;
WPARAM wParam;
*/
{
static DWORD aIds[] = {
IDC_R_WALLS,IDH_R_WALL,
IDC_R_FLOORS,IDH_R_FLOOR,
IDC_R_CEILINGS,IDH_R_CEILING,
IDC_R_SPRITES,IDH_R_SPRITE,
IDC_R_REPLACE,IDH_R_REPLACE,
IDC_R_NEW,IDH_R_NEW,
IDC_R_ORIGINAL,IDH_R_ORIGINAL,
IDC_R_CLOSE,IDH_R_CLOSE,
0,0
};
switch (message)
{
// HERE
case WM_HELP:
WinHelp(((LPHELPINFO) lParam)->hItemHandle, "openglbt.hlp",
HELP_WM_HELP, (DWORD) (LPSTR) aIds);
break;
case WM_CONTEXTMENU:
WinHelp((HWND) wParam, "openglbt.hlp", HELP_CONTEXTMENU,
(DWORD) (LPVOID) aIds);
break;
case WM_INITDIALOG:
SetDlgItemText(hwndDlg,IDC_R_ORIGINAL,"0");
SetDlgItemText(hwndDlg,IDC_R_NEW,"0");
// SetupSpriteProc(hwndDlg);
break;
case WM_CLOSE:
EndDialog(hwndDlg, wParam);
return FALSE;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDOK:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDCANCEL:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDC_R_REPLACE:
ReplaceProc(hwndDlg);
return FALSE;
case IDC_R_CLOSE:
EndDialog(hwndDlg, wParam);
return FALSE;
}
break;
}
return FALSE;
}
void ProcessStubProc(HWND hwndDlg)
{
int original_tile;
int new_tile;
int a;
int count[5]={0,0,0,0,0};
char repstring[80];
original_tile=GetDlgItemInt(hwndDlg,IDC_R_ORIGINAL,NULL,TRUE);
new_tile=GetDlgItemInt(hwndDlg,IDC_R_NEW,NULL,TRUE);
// HERE
if(IsDlgButtonChecked(hwndDlg,IDC_R_CEILINGS)==BST_CHECKED)
for(a=0;a<numsectors;a++)
if(sector[a].ceilingpicnum==original_tile)
{count[0]++;sector[a].ceilingpicnum=new_tile;}
if(IsDlgButtonChecked(hwndDlg,IDC_R_FLOORS)==BST_CHECKED)
for(a=0;a<numsectors;a++)
if(sector[a].floorpicnum==original_tile)
{count[1]++;sector[a].floorpicnum=new_tile;}
if(IsDlgButtonChecked(hwndDlg,IDC_R_WALLS)==BST_CHECKED)
for(a=0;a<numwalls;a++)
{
if(wall[a].picnum==original_tile)
{count[2]++;wall[a].picnum=new_tile;}
if(wall[a].overpicnum==original_tile)
{count[3]++;wall[a].overpicnum=new_tile;}
}
if(IsDlgButtonChecked(hwndDlg,IDC_R_SPRITES)==BST_CHECKED)
for(a=0;a<numsprites;a++)
if(sprite[a].picnum==original_tile)
{count[4]++;sprite[a].picnum=new_tile;}
sprintf(repstring,
"Converted \
%i ceilings, \
%i floors, \
%i walls, \
%i overwals,\nand \
%i sprites from image \
%i to image \
%i.",count[0],count[1],count[2],count[3],count[4],original_tile,new_tile);
MessageBox(NULL, repstring, "Completed", MB_OK);
}
BOOL CALLBACK StubProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
HRSRC stubdata;
LPVOID stubhandle;
HGLOBAL stubblock;
HRSRC stubdata2;
LPVOID stubhandle2;
HGLOBAL stubblock2;
FILE *stubfile;
char a,b;
char inv;
char invr;
char invl;
char holo;
char jp;
char nv;
char med;
char ster;
char kick;
long weapon[10];
long weapon2[10];
char nweap;
char Weapon_[10][10];
char ep1[17];
char ep2[17];
char ep3[17];
char stub_name[13];
char stub_patch[13];
switch (message)
{
/*
case WM_INITDIALOG:
//SetDlgItemText(hwndDlg,IDC_R_ORIGINAL,"0");
//SetDlgItemText(hwndDlg,IDC_R_NEW,"0");
SetDlgItemInt(hwndDlg,STUB_W1,3,TRUE);
SetDlgItemInt(hwndDlg,STUB_W2,2,TRUE);
SetDlgItemInt(hwndDlg,STUB_W3,1,TRUE);
SetDlgItemInt(hwndDlg,STUB_W4,4,TRUE);
SetDlgItemInt(hwndDlg,STUB_W5,5,TRUE);
SetDlgItemInt(hwndDlg,STUB_W6,6,TRUE);
SetDlgItemInt(hwndDlg,STUB_W7,7,TRUE);
SetDlgItemInt(hwndDlg,STUB_W8,8,TRUE);
SetDlgItemInt(hwndDlg,STUB_W9,9,TRUE);
SetDlgItemInt(hwndDlg,STUB_W10,10,TRUE);
break;
//*/
case WM_CLOSE:
EndDialog(hwndDlg, wParam);
return FALSE;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDOK:
nweap=0;
if(IsDlgButtonChecked(hwndDlg,STUB_1)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W1,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_2)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W2,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_3)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W3,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_4)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W4,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_5)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W5,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_6)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W6,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_7)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W7,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_8)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W8,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_9)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W9,NULL,TRUE);nweap++;}
if(IsDlgButtonChecked(hwndDlg,STUB_10)!=BST_CHECKED)
{weapon[nweap]=GetDlgItemInt(hwndDlg,STUB_W10,NULL,TRUE);nweap++;}
for(a=0;a<nweap;a++)
for(b=0;b<nweap;b++)
if(weapon[a]==weapon[b]&&a!=b)
{
MessageBox(NULL, "Weapons may nut be allocated the same number as other weapons.", "Error", MB_OK);
return 1;
}
for(a=0;a<nweap;a++)
if(weapon[a]<1||weapon[a]>10)
{
MessageBox(NULL, "Weapon numbers must be between 1 and 10 inclusive.", "Error", MB_OK);
return 1;
}
weapon[0]=STUB_1;
weapon[1]=STUB_2;
weapon[2]=STUB_3;
weapon[3]=STUB_4;
weapon[4]=STUB_5;
weapon[5]=STUB_6;
weapon[6]=STUB_7;
weapon[7]=STUB_8;
weapon[8]=STUB_9;
weapon[9]=STUB_10;
weapon2[0]=STUB_W1;
weapon2[1]=STUB_W2;
weapon2[2]=STUB_W3;
weapon2[3]=STUB_W4;
weapon2[4]=STUB_W5;
weapon2[5]=STUB_W6;
weapon2[6]=STUB_W7;
weapon2[7]=STUB_W8;
weapon2[8]=STUB_W9;
weapon2[9]=STUB_W10;
for(a=0;a<10;a++)
if(IsDlgButtonChecked(hwndDlg,weapon[a])!=BST_CHECKED)
{ if(GetDlgItemInt(hwndDlg,weapon2[a],NULL,TRUE)<10)
{
sprintf(Weapon_[a],"Weapon_%i",GetDlgItemInt(hwndDlg,weapon2[a],NULL,TRUE));
Weapon_[a][8]=0;
}
else sprintf(Weapon_[a],"Weapon_%i",GetDlgItemInt(hwndDlg,weapon2[a],NULL,TRUE));
}else sprintf(Weapon_[a],"?eapon_??");
if(IsDlgButtonChecked(hwndDlg,STUB_INV)==BST_CHECKED)inv='?';else inv='I';
if(IsDlgButtonChecked(hwndDlg,STUB_INVL)==BST_CHECKED)invl='?';else invl='I';
if(IsDlgButtonChecked(hwndDlg,STUB_INVR)==BST_CHECKED)invr='?';else invr='I';
if(IsDlgButtonChecked(hwndDlg,STUB_HOLO)==BST_CHECKED)holo='?';else holo='H';
if(IsDlgButtonChecked(hwndDlg,STUB_JP)==BST_CHECKED)jp='?';else jp='J';
if(IsDlgButtonChecked(hwndDlg,STUB_NV)==BST_CHECKED)nv='?';else nv='N';
if(IsDlgButtonChecked(hwndDlg,STUB_MED)==BST_CHECKED)med='?';else med='M';
if(IsDlgButtonChecked(hwndDlg,STUB_STER)==BST_CHECKED)ster='?';else ster='S';
if(IsDlgButtonChecked(hwndDlg,STUB_KICK)==BST_CHECKED)kick='?';else kick='Q';
GetDlgItemText(hwndDlg,STUB_LAMEL,ep1,17);
GetDlgItemText(hwndDlg,STUB_LUNAR,ep2,17);
GetDlgItemText(hwndDlg,STUB_SHRAP,ep3,17);
ep1[16]=0;
b=0;
for(a=0;a<16;a++)
{
if(ep1[a]==0)b=1;
if(b==1)
ep1[a]=32;
}
ep2[16]=0;
b=0;
for(a=0;a<16;a++)
{
if(ep2[a]==0)b=1;
if(b==1)
ep2[a]=32;
}
ep3[16]=0;
b=0;
for(a=0;a<16;a++)
{
if(ep3[a]==0)b=1;
if(b==1)
ep3[a]=32;
}
GetDlgItemText(hwndDlg,STUB_NAME,stub_name,13);
for(a=0;a<13;a++)
{
if(
((stub_name[a]<'A'||stub_name[a]>'Z')&&(stub_name[a]<'0'||stub_name[a]>'9'))
||a>=8)
{
stub_name[a]='.';
stub_name[a+1]='C';
stub_name[a+2]='O';
stub_name[a+3]='M';
a+=4;
while(a<13)
{stub_name[a]=0;a++;}
}
}
if(stub_name[0]==0||stub_name[0]=='.')
{
MessageBox(NULL, "The patch file needs a name.", "Error", MB_OK);
return 1;
}
GetDlgItemText(hwndDlg,STUB_PATCH,stub_patch,13);
for(a=0;a<13;a++)
{
if(((stub_patch[a]<'A'||stub_patch[a]>'Z')&&(stub_patch[a]<'0'||stub_patch[a]>'9'))||a>=8)
{
stub_patch[a]='.';
stub_patch[a+1]='E';
stub_patch[a+2]='X';
stub_patch[a+3]='E';
a+=4;
while(a<13)
{stub_patch[a]=0;a++;}
}
}
if(stub_patch[0]==0||stub_patch[0]=='.')
{
MessageBox(NULL, "The patched executionable file needs a name.", "Error", MB_OK);
return 1;
}
stubdata=FindResource(NULL,"#1",RT_RCDATA);
if(stubdata==NULL)
{MessageBox(NULL, "stubdata", "Error", MB_OK);return 1;}
stubblock=LoadResource(NULL,stubdata);
if(stubblock==NULL)
{MessageBox(NULL, "stubblock", "Error", MB_OK);return 1;}
stubhandle=LockResource(stubblock);
if(stubhandle==NULL)
{MessageBox(NULL, "stubhandle", "Error", MB_OK);return 1;}
stubdata2=FindResource(NULL,"#2",RT_RCDATA);
if(stubdata2==NULL)
{MessageBox(NULL, "stubdata2", "Error", MB_OK);return 1;}
stubblock2=LoadResource(NULL,stubdata2);
if(stubblock2==NULL)
{MessageBox(NULL, "stubblock2", "Error", MB_OK);return 1;}
stubhandle2=LockResource(stubblock2);
if(stubhandle2==NULL)
{MessageBox(NULL, "stubhandle2", "Error", MB_OK);return 1;}
if((stubfile=fopen(stub_name,"wb"))==NULL)
{MessageBox(NULL, "Could not open patch file for output.", "Error", MB_OK);return 1;}
//fwrite(stubhandle,11016,1,stubfile);
fwrite(stubhandle,11224,1,stubfile);
fputc(inv,stubfile);
fputc(invr,stubfile);
fputc(invl,stubfile);
fputc(holo,stubfile);
fputc(jp,stubfile);
fputc(nv,stubfile);
fputc(med,stubfile);
fputc(ster,stubfile);
fputc(kick,stubfile);
fputc(0,stubfile);fputc(123,stubfile);fputc(45,stubfile);
for(a=0;a<17;a++)
fputc(ep1[a],stubfile);
for(a=0;a<17;a++)
fputc(ep2[a],stubfile);
for(a=0;a<17;a++)
fputc(ep3[a],stubfile);
for(a=0;a<10;a++)
{
fputs(Weapon_[a],stubfile);fputc(0,stubfile);
if(GetDlgItemInt(hwndDlg,weapon2[a],NULL,TRUE)<10)
fputc(0,stubfile);
}
for(a=0;a<13;a++)
fputc(stub_patch[a],stubfile);
fwrite(stubhandle2,2218,1,stubfile);
fclose(stubfile);
MessageBox(NULL, "Patch file created.", "Success", MB_OK);
EndDialog(hwndDlg, wParam);
return FALSE;
case IDCANCEL:
EndDialog(hwndDlg, wParam);
return FALSE;
}
break;
}
return FALSE;
}
char filename[256];
char smallfilename[256];
char count=0;
long int fileloc[1024];
char filenames[1024][13];
long EntrySize[1024],EntryOffset[1024],remaining;
char EntryName[1024][12];
long IdxCnt;
char DN3GrpSig[12];
char grouppath[256];
long int nSelItems;
long int nSelItemsInBuffer;
long int top_index=0;
char outputstring[256];
//#define variable 2097152
#define variable 7340032
// char bigblock[524288];
//char bigblock[1048576];
char bigblock[variable];
char GROUPFILEISOPEN=0;
char method=0;
UINT APIENTRY OldStyle(HWND hdlg,UINT uiMsg,WPARAM wParam,LPARAM lParam)
{
return false;
}
BOOL CALLBACK GroupProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
char addressstring[25],tempstr[256],tempstr2[256],tempfilename[256];
long int i,i2,i3;
HWND hwndList;
HWND hwndList2;
char temp_name[MAXFILE];
char temp_ext[MAXEXT];
long temp_size=0;
long temp_datasize=0;
char smalltemp_name[MAXFILE];
char smalltemp_ext[MAXEXT];
char smalltemp[256];
long smallfirstoffset;
long smallsecondoffset;
FILE *dukef,*outf,*tempf,*smalltempf;
fpos_t filepos;
DWORD cchCurDir;
LPTSTR lpszCurDir;
LPTSTR lpszFileToDelete;
OPENFILENAME ofn;
ZeroMemory(&ofn, sizeof (OPENFILENAME));
ofn.lStructSize = sizeof (OPENFILENAME);
ofn.hwndOwner=hwndDlg;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.lpfnHook=OldStyle;
if(message!=WM_INITDIALOG)
{
if(count>2)
{
if(SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_GETTOPINDEX,0,0)
!=SendDlgItemMessage(hwndDlg,IDC_GROUPSIZE,LB_GETTOPINDEX,0,0))
{
SendDlgItemMessage(hwndDlg,IDC_GROUPSIZE,LB_SETTOPINDEX,
(WPARAM)SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_GETTOPINDEX,0,0),0);
count=0;
}
}
else
count++;
}
switch (message)
{
case WM_INITDIALOG:
GROUPFILEISOPEN=0;
hwndList = GetDlgItem(hwndDlg, IDC_GROUP);
hwndList2 = GetDlgItem(hwndDlg, IDC_GROUPSIZE);
SendMessage(hwndList,LB_RESETCONTENT,0,0);
SendMessage(hwndList2,LB_RESETCONTENT,0,0);
method=0;
SetDlgItemText(hwndDlg,IDC_METHODTEXT,"Please select a method to add/delete files.");
break;
case WM_CLOSE:
EndDialog(hwndDlg, wParam);
return FALSE;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDC_METHOD1:
SetDlgItemText(hwndDlg,IDC_METHODTEXT,"Method 1 - faster, less permenant space needed. Volotile if your platform crashes.");
method=1;
break;
case IDC_METHOD2:
SetDlgItemText(hwndDlg,IDC_METHODTEXT,"Method 2 - slower, more permenant space needed. Safer in the event of your platform crashing.");
method=2;
break;
case IDC_ADDFILE:
if(method==0){MessageBox(NULL,"You must select a method to process the file with.","Error", MB_OK);return 1;}
if(!GROUPFILEISOPEN){MessageBox(NULL,"You must either open or create a new group file first.", "Error", MB_OK);return 1;}
ofn.nMaxFile = sizeof (smallfilename);
ofn.lpstrFilter =
"Animation files\0*.ANM\0\
Art files\0*.ART\0\
Configuration files\0*.CFG\0\
Control files\0*.CON\0\
Data files\0*.BIN;*.DAT;*.TMB\0\
Demonstration\0*.DMO\0\
Documentation files\0*.DOC;*.HLP;*.TXT;*.RTF\0\
Executionable files\0*.BAT;*.COM;*.EXE\0\
Group files\0*.GRP\0\
Initialisation files\0*.INI\0\
Map files\0*.MAP\0\
MIDI files\0*.MID\0\
RTS files\0*.RTS\0\
Save game files\0*.SAV\0\
Temporary files\0*.$$$\0\
Voice files\0*.VOC\0\
Wave files\0*.WAV\0\
et al.\0*.$$$;*.ANM;*.ART;*.BAT;*.BIN;*.CFG;*.COM;*.CON;*.DAT;*.DMO;*.DOC;*.EXE;*.GRP;*.HLP;*.INI;*.MAP;*.MID;*.RTF;*.RTS;*.SAV;*.TMB;*.TXT;*.VOC;*.WAV\0\
All\0*.*\0\0";
ofn.nFilterIndex = 19;
ofn.lpstrDefExt= NULL;
hwndList = GetDlgItem(hwndDlg, IDC_GROUP);
hwndList2 = GetDlgItem(hwndDlg, IDC_GROUPSIZE);
ofn.lpstrFile = smallfilename;
ofn.Flags = OFN_ENABLEHOOK|OFN_NOLONGNAMES|OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
if (GetOpenFileName(&ofn)!=TRUE)return 1;
fnsplit(smallfilename,NULL,NULL,smalltemp_name,smalltemp_ext);
sprintf(smalltemp,"%s%s",smalltemp_name,smalltemp_ext);
i=SendMessage(hwndList,LB_FINDSTRINGEXACT,0,(LPARAM)smalltemp);
if(LB_ERR!=i)
{MessageBox(NULL,"File already exists.", "Error", MB_OK);return false;}
if(method==1)
{
if((dukef=fopen(filename,"r+b"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
if((smalltempf=fopen(smallfilename,"rb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
fseek(dukef,0,2);
temp_size=ftell(dukef);
fseek(dukef,0,0);
fseek(smalltempf,0,2);
i=ftell(smalltempf);
fseek(smalltempf,0,0);
smallsecondoffset=temp_size-IdxCnt*16-16;
smallfirstoffset=IdxCnt*16+16;
while(smallsecondoffset>variable)
{
fseek(dukef,smallfirstoffset,0);
fseek(dukef,smallsecondoffset-variable,1);
fread(&bigblock,variable,1,dukef);
fseek(dukef,16,1);
fwrite(&bigblock,variable,1,dukef);
sprintf(tempstr,"Writing data - %li",smallsecondoffset);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
smallsecondoffset-=variable;
}
if(smallsecondoffset>0)
{
fseek(dukef,smallfirstoffset,0);
fread(&bigblock,smallsecondoffset,1,dukef);
fseek(dukef,16,1);
fwrite(&bigblock,smallsecondoffset,1,dukef);
sprintf(tempstr,"Writing data - 0");
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
}
filenames[IdxCnt][12]=0;
EntrySize[IdxCnt]=i;
sprintf(filenames[IdxCnt],smalltemp);
sprintf(tempstr,"%li",EntrySize[IdxCnt]);
SendMessage(hwndList,LB_ADDSTRING,IdxCnt,(LPARAM)filenames[IdxCnt]);
SendMessage(hwndList,LB_SETITEMDATA,IdxCnt,(LPARAM)IdxCnt);
SendMessage(hwndList2,LB_ADDSTRING,IdxCnt,(LPARAM)tempstr);
SendMessage(hwndList2,LB_SETITEMDATA,IdxCnt,(LPARAM)IdxCnt);
fseek(dukef,0,2);
while(i>variable)
{
fread(&bigblock,variable,1,smalltempf);
fwrite(&bigblock,variable,1,dukef);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
sprintf(tempstr,"Writing new data - %li",i);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
i-=variable;
}
if(i>0)
{
fread(&bigblock,i,1,smalltempf);
fwrite(&bigblock,i,1,dukef);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing new data - 0");
}
sprintf(tempstr,"Updating header",i);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
fseek(dukef,IdxCnt*16+16,0);
sprintf(smalltemp,"%s%s",smalltemp_name,smalltemp_ext);
fwrite(smalltemp,12,1,dukef);
fwrite(&EntrySize[IdxCnt],4,1,dukef);
fseek(dukef,12,0);
IdxCnt++;
fwrite(&IdxCnt,4,1,dukef);
fclose(dukef);
fclose(smalltempf);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
}
else
{
if((dukef=fopen(filename,"rb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
if((smalltempf=fopen(smallfilename,"rb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
tmpnam(tempfilename);
if((tempf=fopen(tempfilename,"wb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
fseek(dukef,0,2);
temp_size=ftell(dukef);
fseek(dukef,0,0);
fseek(smalltempf,0,2);
i=ftell(smalltempf);
fseek(smalltempf,0,0);
smallfirstoffset=IdxCnt*16+16;
while(smallfirstoffset>variable)
{
fread(&bigblock,variable,1,dukef);
fwrite(&bigblock,variable,1,tempf);
smallfirstoffset-=variable;
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing header");
}
if(smallfirstoffset>0)
{
fread(&bigblock,smallfirstoffset,1,dukef);
fwrite(&bigblock,smallfirstoffset,1,tempf);
}
sprintf(smalltemp,"%s%s",smalltemp_name,smalltemp_ext);
fwrite(smalltemp,12,1,tempf);
fwrite(&i,4,1,tempf);
smallsecondoffset=temp_size-IdxCnt*16-16;
while(smallsecondoffset>variable)
{
fread(&bigblock,variable,1,dukef);
fwrite(&bigblock,variable,1,tempf);
sprintf(tempstr,"Writing data - %li/%li",smallsecondoffset,temp_size);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
smallsecondoffset-=variable;
}
if(smallsecondoffset>0)
{
fread(&bigblock,smallsecondoffset,1,dukef);
fwrite(&bigblock,smallsecondoffset,1,tempf);
sprintf(tempstr,"Writing data - 0/%li",temp_size);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
}
filenames[IdxCnt][12]=0;
EntrySize[IdxCnt]=i;
sprintf(filenames[IdxCnt],smalltemp);
sprintf(tempstr,"%li",EntrySize[IdxCnt]);
SendMessage(hwndList,LB_ADDSTRING,IdxCnt,(LPARAM)filenames[IdxCnt]);
SendMessage(hwndList,LB_SETITEMDATA,IdxCnt,(LPARAM)IdxCnt);
SendMessage(hwndList2,LB_ADDSTRING,IdxCnt,(LPARAM)tempstr);
SendMessage(hwndList2,LB_SETITEMDATA,IdxCnt,(LPARAM)IdxCnt);
while(i>variable)
{
fread(&bigblock,variable,1,smalltempf);
fwrite(&bigblock,variable,1,tempf);
sprintf(tempstr,"Writing new data - %li",i);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
i-=variable;
}
if(i>0)
{
fread(&bigblock,i,1,smalltempf);
fwrite(&bigblock,i,1,tempf);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing new data - 0");
}
fseek(tempf,12,0);
IdxCnt++;
fwrite(&IdxCnt,4,1,tempf);
fclose(dukef);
fclose(tempf);
fclose(smalltempf);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Replacing");
if(remove(filename)!=0)
{
sprintf(tempstr,"Could not remove %s!\nTemporary file saved as %s.",filename,tempfilename);
MessageBox(NULL,tempstr, "Error", MB_OK);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
return false;
}
if(rename(tempfilename,filename)!=0)
{
sprintf(tempstr,"Could not rename %s to %s!\nTemporary file saved as %s.",tempfilename,filename,tempfilename);
MessageBox(NULL,tempstr, "Error", MB_OK);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
return false;
}
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
}
break;
case IDC_DELETEFILE:
hwndList = GetDlgItem(hwndDlg, IDC_GROUP);
hwndList2 = GetDlgItem(hwndDlg, IDC_GROUPSIZE);
if(!GROUPFILEISOPEN){MessageBox(NULL,"You must either open or create a new group file first.", "Error", MB_OK);return 1;}
nSelItems=SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_GETSELITEMS,(WPARAM)1024,(LPARAM)(LPINT)fileloc);
if((dukef=fopen(filename,"rb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
tmpnam(tempfilename);
if((tempf=fopen(tempfilename,"wb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing header info");
fwrite("KenSilverman",12,1,tempf);
i=IdxCnt-nSelItems;
fwrite(&i,4,1,tempf);
smallfirstoffset=0;
fseek(dukef,16,0);
for(i=0;i<nSelItems;i++)
{
sprintf(tempstr,"Writing header block %li",i+1);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
fread(bigblock,fileloc[i]*16-smallfirstoffset,1,dukef);
fwrite(bigblock,fileloc[i]*16-smallfirstoffset,1,tempf);
smallfirstoffset=fileloc[i]*16+16;
fseek(dukef,16,1);
}
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing last header block");
fread(bigblock,IdxCnt*16-smallfirstoffset,1,dukef);
fwrite(bigblock,IdxCnt*16-smallfirstoffset,1,tempf);
fseek(dukef,16,1);
smallfirstoffset=IdxCnt*16+16;
for(i=0;i<nSelItems;i++)
{
sprintf(tempstr,"Writing data block %li",i+1);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
fseek(dukef,smallfirstoffset,0);
smallsecondoffset=EntryOffset[fileloc[i]];
while(smallsecondoffset-smallfirstoffset>variable)
{
fread(bigblock,variable,1,dukef);
fwrite(bigblock,variable,1,tempf);
}
if(smallsecondoffset-smallfirstoffset>0)
{
fread(bigblock,smallsecondoffset-smallfirstoffset,1,dukef);
fwrite(bigblock,smallsecondoffset-smallfirstoffset,1,tempf);
}
smallfirstoffset=smallsecondoffset+EntrySize[fileloc[i]];
}
fseek(dukef,smallfirstoffset,0);
smallsecondoffset=EntryOffset[IdxCnt];
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Writing last data block");
while(smallsecondoffset-smallfirstoffset>variable)
{
fread(bigblock,variable,1,dukef);
fwrite(bigblock,variable,1,tempf);
}
if(smallsecondoffset-smallfirstoffset>0)
{
fread(bigblock,smallsecondoffset-smallfirstoffset,1,dukef);
fwrite(bigblock,smallsecondoffset-smallfirstoffset,1,tempf);
}
fclose(tempf);
fclose(dukef);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Replacing");
if(remove(filename)!=0)
{
sprintf(tempstr,"Could not remove %s!\nTemporary file saved as %s.",filename,tempfilename);
MessageBox(NULL,tempstr, "Error", MB_OK);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
return false;
}
if(rename(tempfilename,filename)!=0)
{
sprintf(tempstr,"Could not rename %s to %s!\nTemporary file saved as %s.",tempfilename,filename,tempfilename);
MessageBox(NULL,tempstr, "Error", MB_OK);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
return false;
}
/*
vector<int> vsize(EntrySize, EntrySize+1024);
vector<int> voffset(EntryOffset, EntryOffset+1024);
vector<int> vname(EntryName, EntryName+1024);
vector<int> vfilenames(filenames, filenames+1024);
remove_if(vsize.begin()+i,vsize.begin()+i+1,all_true<int>());
remove_if(voffsett.begin()+i,voffsett.begin()+i+1,all_true<int>());
remove_if(vname.begin()+i,vname.begin()+i+1,all_true<int>());
remove_if(vfilename.begin()+i,vfilename.begin()+i+1,all_true<int>());
*/
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Reopening");
SendMessage(hwndList,LB_RESETCONTENT,0,0);
SendMessage(hwndList2,LB_RESETCONTENT,0,0);
GROUPFILEISOPEN=0;
SetDlgItemText(hwndDlg,IDC_GROUPNAME,"File name:\nFile size: 0\nNumber of entries: 0\nTotal data size: 0");
if((dukef=fopen(filename,"rb"))==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");return false;}
fread(DN3GrpSig,12,1,dukef);
fread(&IdxCnt,4,1,dukef);
EntryOffset[0]=(IdxCnt+1)*16;//<<4;
for(i=0;i<IdxCnt;i++)
{
fread(EntryName[i],12,1,dukef);
fread(&EntrySize[i],4,1,dukef);
sprintf(filenames[i],"%s",EntryName[i]);
filenames[i][12]=0;
SendMessage(hwndList,LB_ADDSTRING,i,(LPARAM)filenames[i]);
SendMessage(hwndList,LB_SETITEMDATA,i,(LPARAM)i);
sprintf(tempstr,"%li",EntrySize[i]);
SendMessage(hwndList2,LB_ADDSTRING,i,(LPARAM)tempstr);
SendMessage(hwndList2,LB_SETITEMDATA,i,(LPARAM)i);
temp_datasize+=EntrySize[i];
if(i<1023)
EntryOffset[i+1]=EntrySize[i]+EntryOffset[i];
}
fseek(dukef,0,2);
temp_size=ftell(dukef);
fclose(dukef);
GetCurrentDirectory(256,grouppath);
SetDlgItemText(hwndDlg,IDC_GROUPPATH,grouppath);
fnsplit(filename,NULL,NULL,temp_name,temp_ext);
sprintf(outputstring,"File name: %s%s\nFile size: %li\nNumber of entries: %li\nTotal data size: %li",temp_name,temp_ext,temp_size,IdxCnt,temp_datasize);
SetDlgItemText(hwndDlg,IDC_GROUPNAME,outputstring);
GROUPFILEISOPEN=1;
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
break;
case IDC_OPEN:
ofn.nMaxFile = sizeof (filename);
ofn.lpstrFilter = "Group files\0*.GRP\0Temporary files\0*.$$$\0All\0*.*\0";
ofn.nFilterIndex = 1;
ofn.lpstrDefExt= "GRP\0";
ofn.lpstrFile = filename;
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
hwndList = GetDlgItem(hwndDlg, IDC_GROUP);
hwndList2 = GetDlgItem(hwndDlg, IDC_GROUPSIZE);
SendMessage(hwndList,LB_RESETCONTENT,0,0);
SendMessage(hwndList2,LB_RESETCONTENT,0,0);
GROUPFILEISOPEN=0;
SetDlgItemText(hwndDlg,IDC_GROUPNAME,"File name:\nFile size: 0\nNumber of entries: 0\nTotal data size: 0");
if (GetOpenFileName(&ofn)!=TRUE)return 1;
dukef=fopen(filename,"rb");
if(dukef==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
if(fread(DN3GrpSig,12,1,dukef)!=1)
{MessageBox(NULL,"Error while reading from file.", "Error", MB_OK);return false;}
else
if(DN3GrpSig[0]!='K'||DN3GrpSig[1]!='e'||DN3GrpSig[2]!='n'||DN3GrpSig[3]!='S'||DN3GrpSig[4]!='i'||DN3GrpSig[5]!='l'||DN3GrpSig[6]!='v'||DN3GrpSig[7]!='e'||DN3GrpSig[8]!='r'||DN3GrpSig[9]!='m'||DN3GrpSig[10]!='a'||DN3GrpSig[11]!='n')
{MessageBox(NULL,"File seems to be of a different format.", "Error", MB_OK);return false;}
fread(&IdxCnt,4,1,dukef);
EntryOffset[0]=(IdxCnt+1)*16;//<<4;
for(i=0;i<IdxCnt;i++)
{
fread(EntryName[i],12,1,dukef);
fread(&EntrySize[i],4,1,dukef);
sprintf(filenames[i],"%s",EntryName[i]);
filenames[i][12]=0;
SendMessage(hwndList,LB_ADDSTRING,i,(LPARAM)filenames[i]);
SendMessage(hwndList,LB_SETITEMDATA,i,(LPARAM)i);
sprintf(tempstr,"%li",EntrySize[i]);
SendMessage(hwndList2,LB_ADDSTRING,i,(LPARAM)tempstr);
SendMessage(hwndList2,LB_SETITEMDATA,i,(LPARAM)i);
temp_datasize+=EntrySize[i];
if(i<1023)
EntryOffset[i+1]=EntrySize[i]+EntryOffset[i];
}
fseek(dukef,0,2);
temp_size=ftell(dukef);
fclose(dukef);
GetCurrentDirectory(256,grouppath);
SetDlgItemText(hwndDlg,IDC_GROUPPATH,grouppath);
fnsplit(filename,NULL,NULL,temp_name,temp_ext);
sprintf(outputstring,
"File name: %s%s\nFile size: %li\nNumber of entries: %li\nTotal data size: %li",temp_name,temp_ext,temp_size,IdxCnt,temp_datasize);
SetDlgItemText(hwndDlg,IDC_GROUPNAME,outputstring);
GROUPFILEISOPEN=1;
break;
case IDC_NEW:
ofn.nMaxFile = sizeof (filename);
ofn.lpstrFilter = "Group files\0*.GRP\0Temporary files\0*.$$$\0All\0*.*\0";
ofn.nFilterIndex = 1;
ofn.lpstrDefExt= "GRP\0";
ofn.lpstrFile = filename;
ofn.Flags = OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
hwndList = GetDlgItem(hwndDlg, IDC_GROUP);
hwndList2 = GetDlgItem(hwndDlg, IDC_GROUPSIZE);
SendMessage(hwndList,LB_RESETCONTENT,0,0);
SendMessage(hwndList2,LB_RESETCONTENT,0,0);
GROUPFILEISOPEN=0;
SetDlgItemText(hwndDlg,IDC_GROUPNAME,"File name:\nFile size: 0\nNumber of entries: 0\nTotal data size: 0");
if (GetSaveFileName(&ofn)!=TRUE)return 1;
dukef=fopen(filename,"wb");
if(dukef==NULL)
{MessageBox(NULL,"Can not open the file.", "Error", MB_OK);return false;}
IdxCnt=0;
fwrite("KenSilverman",12,1,dukef);
fwrite(&IdxCnt,4,1,dukef);
fclose(dukef);
GetCurrentDirectory(256,grouppath);
SetDlgItemText(hwndDlg,IDC_GROUPPATH,grouppath);
fnsplit(filename,NULL,NULL,temp_name,temp_ext);
sprintf(outputstring,"File name: %s%s\nFile size: 12\nNumber of entries: 0\nTotal data size: 0",temp_name,temp_ext);
SetDlgItemText(hwndDlg,IDC_GROUPNAME,outputstring);
GROUPFILEISOPEN=1;
break;
case IDOK:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDC_GROUPEXTRACT:
if(!GROUPFILEISOPEN){MessageBox(NULL,"You must either open or create a new group file first.", "Error", MB_OK);return 1;}
{
nSelItems=SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_GETSELITEMS,(WPARAM)1024,(LPARAM)(LPINT)fileloc);
GetDlgItemText(hwndDlg,IDC_GROUPPATH,grouppath,256);
i=strlen(grouppath);
if(i>0)
{
if(grouppath[i-1]!='\\')
{
grouppath[i+1]=grouppath[i];
grouppath[i]='\\';
}
}
SetCurrentDirectory(grouppath);
if(nSelItems==0)
{
if(MessageBox(NULL,"Do you want to extract all of the files?", "No files have been selected", MB_YESNO)==IDYES)
{
SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_SELITEMRANGEEX,0,IdxCnt-1);
nSelItems=SendDlgItemMessage(hwndDlg,IDC_GROUP,LB_GETSELITEMS,(WPARAM)1024,(LPARAM)(LPINT)fileloc);
}
else return false;
}
if((dukef=fopen(filename,"rb"))==NULL)
{
sprintf(tempstr,"Could not open the input file.");
MessageBox(NULL,tempstr, "Error", MB_OK);
return false;
}
else
for(i=0;i<nSelItems;i++)
{
sprintf(tempstr,"%s%s",grouppath,filenames[fileloc[i]]);
if((outf=fopen(tempstr,"wb"))==NULL)
{
sprintf(tempstr,"Could not open the file %s%s for output.",grouppath,filenames[fileloc[i]]);
MessageBox(NULL,tempstr, "Error", MB_OK);
}
else
{
remaining=EntrySize[fileloc[i]];
fsetpos(dukef,&EntryOffset[fileloc[i]]);
sprintf(tempstr,"%s - %li/%li",filenames[fileloc[i]],remaining,EntrySize[fileloc[i]]);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
while(remaining>variable)
{
fread(&bigblock,variable,1,dukef);
if(fwrite(&bigblock,variable,1,outf)!=1)
{
sprintf(tempstr,"Not enough space in target directory/drive.\nStopped at %s.",filenames[fileloc[i]]);
MessageBox(NULL,tempstr, "Insufficiant Space", MB_OK);
return false;
}
remaining-=variable;
sprintf(tempstr,"%s - %li/%li",filenames[fileloc[i]],remaining,EntrySize[fileloc[i]]);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
}
if(remaining>0&&remaining<variable)
{
if(fread(&bigblock,remaining,1,dukef)!=1)
{
MessageBox(NULL,"Error while reading from input file.", "Error", MB_OK);
return false;
}
if(fwrite(&bigblock,remaining,1,outf)!=1)
{
sprintf(tempstr,"Not enough space in target directory/drive.\nStopped at %s.",filenames[fileloc[i]]);
MessageBox(NULL,tempstr, "Insufficiant Space", MB_OK);
return false;
}
sprintf(tempstr,"%s\n 0/%i",filenames[fileloc[i]],EntrySize[fileloc[i]]);
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,tempstr);
}
}
fclose(outf);
}
SetDlgItemText(hwndDlg,IDC_GROUPTEXT,"Idle");
fclose(dukef);
}
return FALSE;
}
break;
}
return FALSE;
}
void SaveSectorProc(HWND hwndDlg)
{
char *endptr;
//CURSECT=GetDlgItemInt(hwndDlg,ID_SECTORNUM,NULL, TRUE);
sector[CURSECT].wallptr=GetDlgItemInt(hwndDlg,ID_FIRSTWALL,NULL,TRUE);
sector[CURSECT].wallnum=GetDlgItemInt(hwndDlg,ID_NUMWALL,NULL,TRUE);
sector[CURSECT].visibility=GetDlgItemInt(hwndDlg,ID_VIS,NULL,TRUE);
sector[CURSECT].lotag=GetDlgItemInt(hwndDlg,ID_LOTAG,NULL,TRUE);
sector[CURSECT].hitag=GetDlgItemInt(hwndDlg,ID_HITAG,NULL,TRUE);
sector[CURSECT].extra=GetDlgItemInt(hwndDlg,ID_EXTRA,NULL,TRUE);
sector[CURSECT].floorheinum=GetDlgItemInt(hwndDlg,ID_FHEINUM,NULL,TRUE);
sector[CURSECT].floorpicnum=GetDlgItemInt(hwndDlg,ID_FPIC,NULL,TRUE);
sector[CURSECT].floorshade=GetDlgItemInt(hwndDlg,ID_FSHADE,NULL,TRUE);
sector[CURSECT].floorpal=GetDlgItemInt(hwndDlg,ID_FPAL,NULL,TRUE);
sector[CURSECT].floorxpanning=GetDlgItemInt(hwndDlg,ID_FX,NULL,TRUE);
sector[CURSECT].floorypanning=GetDlgItemInt(hwndDlg,ID_FY,NULL,TRUE);
sector[CURSECT].ceilingheinum=GetDlgItemInt(hwndDlg,ID_CHEINUM,NULL,TRUE);
sector[CURSECT].ceilingpicnum=GetDlgItemInt(hwndDlg,ID_CPIC,NULL,TRUE);
sector[CURSECT].ceilingshade=GetDlgItemInt(hwndDlg,ID_CSHADE,NULL,TRUE);
sector[CURSECT].ceilingpal=GetDlgItemInt(hwndDlg,ID_CPAL,NULL,TRUE);
sector[CURSECT].ceilingxpanning=GetDlgItemInt(hwndDlg,ID_CX,NULL,TRUE);
sector[CURSECT].ceilingypanning=GetDlgItemInt(hwndDlg,ID_CY,NULL,TRUE);
GetDlgItemText(hwndDlg,ID_FZ,szItemName,260);
sector[CURSECT].floorz = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,ID_CZ,szItemName,260);
sector[CURSECT].ceilingz = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,IDP_X,szItemName,260);
posx = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,IDP_Y,szItemName,260);
posy = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,IDP_Z,szItemName,260);
posz = strtol(szItemName, &endptr, 10);
ang = GetDlgItemInt(hwndDlg,IDP_ANG,NULL,TRUE);
cursectnum = GetDlgItemInt(hwndDlg,IDP_SECTOR,NULL,TRUE);
sector[CURSECT].floorstat=0;
if(IsDlgButtonChecked(hwndDlg,ID_FPARALAX)==BST_CHECKED)
sector[CURSECT].floorstat+=1;
if(IsDlgButtonChecked(hwndDlg,ID_FSLOPE)==BST_CHECKED)
sector[CURSECT].floorstat+=2;
if(IsDlgButtonChecked(hwndDlg,ID_FSWAP)==BST_CHECKED)
sector[CURSECT].floorstat+=4;
if(IsDlgButtonChecked(hwndDlg,ID_FSMOOTH)==BST_CHECKED)
sector[CURSECT].floorstat+=8;
if(IsDlgButtonChecked(hwndDlg,ID_FXFLIP)==BST_CHECKED)
sector[CURSECT].floorstat+=16;
if(IsDlgButtonChecked(hwndDlg,ID_FYFLIP)==BST_CHECKED)
sector[CURSECT].floorstat+=32;
if(IsDlgButtonChecked(hwndDlg,ID_FALIGN)==BST_CHECKED)
sector[CURSECT].floorstat+=64;
sector[CURSECT].ceilingstat=0;
if(IsDlgButtonChecked(hwndDlg,ID_CPARALAX)==BST_CHECKED)
sector[CURSECT].ceilingstat+=1;
if(IsDlgButtonChecked(hwndDlg,ID_CSLOPE)==BST_CHECKED)
sector[CURSECT].ceilingstat+=2;
if(IsDlgButtonChecked(hwndDlg,ID_CSWAP)==BST_CHECKED)
sector[CURSECT].ceilingstat+=4;
if(IsDlgButtonChecked(hwndDlg,ID_CSMOOTH)==BST_CHECKED)
sector[CURSECT].ceilingstat+=8;
if(IsDlgButtonChecked(hwndDlg,ID_CXFLIP)==BST_CHECKED)
sector[CURSECT].ceilingstat+=16;
if(IsDlgButtonChecked(hwndDlg,ID_CYFLIP)==BST_CHECKED)
sector[CURSECT].ceilingstat+=32;
if(IsDlgButtonChecked(hwndDlg,ID_CALIGN)==BST_CHECKED)
sector[CURSECT].ceilingstat+=64;
}
void SaveWallProc(HWND hwndDlg)
{
char *endptr;
//CURWALL=GetDlgItemInt(hwndDlg,ID_WNUM,NULL, TRUE);
wall[CURWALL].lotag=GetDlgItemInt(hwndDlg,ID_WLOTAG,NULL,TRUE);
wall[CURWALL].hitag=GetDlgItemInt(hwndDlg,ID_WHITAG,NULL,TRUE);
wall[CURWALL].extra=GetDlgItemInt(hwndDlg,ID_WEXTRA,NULL,TRUE);
wall[CURWALL].point2=GetDlgItemInt(hwndDlg,ID_WPOINT2,NULL,TRUE);
wall[CURWALL].nextwall=GetDlgItemInt(hwndDlg,ID_WNEXTW,NULL,TRUE);
wall[CURWALL].nextsector=GetDlgItemInt(hwndDlg,ID_WNEXTS,NULL,TRUE);
wall[CURWALL].picnum=GetDlgItemInt(hwndDlg,ID_WPIC,NULL,TRUE);
wall[CURWALL].overpicnum=GetDlgItemInt(hwndDlg,ID_WOVERPIC,NULL,TRUE);
wall[CURWALL].shade=GetDlgItemInt(hwndDlg,ID_WSHADE,NULL,TRUE);
wall[CURWALL].pal=GetDlgItemInt(hwndDlg,ID_WPAL,NULL,TRUE);
wall[CURWALL].xrepeat=GetDlgItemInt(hwndDlg,ID_WXREP,NULL,TRUE);
wall[CURWALL].yrepeat=GetDlgItemInt(hwndDlg,ID_WYREP,NULL,TRUE);
wall[CURWALL].xpanning=GetDlgItemInt(hwndDlg,ID_WXPAN,NULL,TRUE);
wall[CURWALL].ypanning=GetDlgItemInt(hwndDlg,ID_WYPAN,NULL,TRUE);
GetDlgItemText(hwndDlg,ID_WX,szItemName,260);
wall[CURWALL].x = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,ID_WY,szItemName,260);
wall[CURWALL].y = strtol(szItemName, &endptr, 10);
wall[CURWALL].cstat=0;
if(IsDlgButtonChecked(hwndDlg,ID_WBLOCKED)==BST_CHECKED)
wall[CURWALL].cstat+=1;
if(IsDlgButtonChecked(hwndDlg,ID_WSWAPPED)==BST_CHECKED)
wall[CURWALL].cstat+=2;
if(IsDlgButtonChecked(hwndDlg,ID_WALIGNED)==BST_CHECKED)
wall[CURWALL].cstat+=4;
if(IsDlgButtonChecked(hwndDlg,ID_WXFLIP)==BST_CHECKED)
wall[CURWALL].cstat+=8;
if(IsDlgButtonChecked(hwndDlg,ID_WMASKED)==BST_CHECKED)
wall[CURWALL].cstat+=16;
if(IsDlgButtonChecked(hwndDlg,ID_WONEWAY)==BST_CHECKED)
wall[CURWALL].cstat+=32;
if(IsDlgButtonChecked(hwndDlg,ID_WHITSCAN)==BST_CHECKED)
wall[CURWALL].cstat+=64;
if(IsDlgButtonChecked(hwndDlg,ID_WTRANS)==BST_CHECKED)
wall[CURWALL].cstat+=128;
if(IsDlgButtonChecked(hwndDlg,ID_WYFLIP)==BST_CHECKED)
wall[CURWALL].cstat+=256;
if(IsDlgButtonChecked(hwndDlg,ID_WREV)==BST_CHECKED)
wall[CURWALL].cstat+=512;
//DlgDirList(hwndDlg,"*.map",IDC_LISTBOX1,0,DDL_ARCHIVE|DDL_READWRITE|DDL_READONLY|DDL_EXCLUSIVE);
}
//#define IDC_CHECKBOX1 103
BOOL CALLBACK DeleteItemProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
/*
BOOL CALLBACK DeleteItemProc(hwndDlg, message, wParam, lParam)
HWND hwndDlg;
UINT message;
WPARAM wParam;
//LPARAM lParam;
*/
{
//HANDLE hf; // file handle
register long a;
OPENFILENAME ofn; // common dialog box structure
ZeroMemory(&ofn, sizeof (OPENFILENAME));
ofn.lStructSize = sizeof (OPENFILENAME);
ofn.hwndOwner = hwndDlg;
ofn.lpstrFile = szFile;
ofn.nMaxFile = sizeof (szFile);
ofn.lpstrFilter = "Maps\0*.MAP\0All\0*.*\0";
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.lpstrDefExt= "MAP\0";
//#define ID_PARRALAXED 103
//#define ID_ITEMNAME 101
//#define ID_ITEMNAME2 102
//#define IDC_LISTBOX1 104
static DWORD aIds[] = {
ID_FPARALAX, IDH_O_PARALLAX,
ID_FSLOPE, IDH_O_SLOPED,
ID_FSWAP, IDH_O_SWAP,
ID_FSMOOTH, IDH_O_SMOOTH,
ID_FXFLIP, IDH_O_XFLIP,
ID_FYFLIP, IDH_O_YFLIP,
ID_FALIGN, IDH_O_ALIGN,
ID_FZ, IDH_O_Z,
ID_FHEINUM, IDH_O_SLOPE,
ID_FPIC, IDH_O_TEXTURE,
ID_FSHADE, IDH_O_SHADE,
ID_FPAL, IDH_O_PALETTE,
ID_FX, IDH_O_XOFF,
ID_FY, IDH_O_YOFF,
ID_CPARALAX, IDH_O_PARALLAX,
ID_CSLOPE, IDH_O_SLOPED,
ID_CSWAP, IDH_O_SWAP,
ID_CSMOOTH, IDH_O_SMOOTH,
ID_CXFLIP, IDH_O_XFLIP,
ID_CYFLIP, IDH_O_YFLIP,
ID_CALIGN, IDH_O_ALIGN,
ID_CZ, IDH_O_Z,
ID_CHEINUM, IDH_O_SLOPE,
ID_CPIC, IDH_O_TEXTURE,
ID_CSHADE, IDH_O_SHADE,
ID_CPAL, IDH_O_PALETTE,
ID_CX, IDH_O_XOFF,
ID_CY, IDH_O_YOFF,
ID_SECTORNUM, IDH_O_CSECT,
IDCURSECT, IDH_O_CSECTSEL,
ID_FIRSTWALL, IDH_O_FWALL,
IDFIRSTWALL, IDH_O_FWALLSEL,
ID_NUMWALL, IDH_O_NWALLS,
ID_VIS, IDH_O_VISIBILITY,
ID_LOTAG, IDH_O_LOTAG,
ID_HITAG, IDH_O_HITAG,
ID_EXTRA, IDH_O_EXTRA,
IDLAST, IDH_O_LAST,
IDNEXT, IDH_O_NEXT,
IDFLAST, IDH_O__LAST,
IDFNEXT, IDH_O__NEXT,
IDNEWWALL, IDH_O_NEWWALL,
IDNEWSECTOR, IDH_O_NEWSECT,
IDNEWMAP, IDH_O_NEWMAP,
ID_WX, IDH_W_X,
ID_WY, IDH_W_Y,
ID_WPIC, IDH_W_TEXTURE,
ID_WOVERPIC, IDH_W_MASK,
ID_WSHADE, IDH_W_SHADE,
ID_WPAL, IDH_W_PALETTE,
ID_WXREP, IDH_W_XREP,
ID_WYREP, IDH_W_YREP,
ID_WXPAN, IDH_W_XPAN,
ID_WYPAN, IDH_W_YPAN,
ID_WLOTAG, IDH_W_LOTAG,
ID_WHITAG, IDH_W_HITAG,
ID_WEXTRA, IDH_W_EXTRA,
ID_WBLOCKED, IDH_W_BLOCK,
ID_WSWAPPED, IDH_W_SWAP,
ID_WALIGNED, IDH_W_ALIGN,
ID_WMASKED, IDH_W_MASKED,
ID_WHITSCAN, IDH_W_HITSCAN,
ID_WONEWAY, IDH_W_ONEWAY,
ID_WNUM, IDH_W_CWALL,
IDCURRENTWALL, IDH_W_CWALLSEL,
ID_WPOINT2, IDH_W_AWALL,
IDADJACENTWALL, IDH_W_AWALLSEL,
ID_WNEXTW, IDH_W_JWALL,
IDJOININGWALL, IDH_W_JWALLSEL,
ID_WNEXTS, IDH_W_JSECT,
IDJOININGSECTOR, IDH_W_JSECTSEL,
ID_WXFLIP, IDH_W_XFLIP,
ID_WYFLIP, IDH_W_YFLIP,
ID_WTRANS, IDH_W_TRANSLUCENCE,
ID_WREV, IDH_W_REVERSING,
IDWLAST, IDH_W_LAST,
IDWNEXT, IDH_W_NEXT,
IDWFLAST, IDH_W__LAST,
IDWFNEXT, IDH_W__NEXT,
IDOPEN, IDH_M_OPEN,
IDSAVE, IDH_M_SAVE,
IDSAVEAS, IDH_M_SAVEAS,
IDP_X, IDH_M_X,
IDP_Y, IDH_M_Y,
IDP_Z, IDH_M_Z,
IDP_ANG, IDH_M_ANG,
IDP_SECTOR, IDH_M_SECTOR,
IDO_SEENINEAPPLY, IDH_M_SAPPLY,
IDO_SEENINEREMOVE, IDH_M_SREMOVE,
IDO_CRACKAPPLY, IDH_M_CAPPLY,
IDO_CRACKREMOVE, IDH_M_CREMOVE,
IDO_REPLACE, IDH_M_REPLACE,
IDC_SINFOBOX, IDH_M_INFOBOX,
IDC_SINFO, IDH_M_INFO,
IDC_ADDRESS, IDH_M_ADDRESS,
0,0
};
switch (message)
{
case WM_INITDIALOG:
//SetDlgItemText(hwndDlg,IDC_ABOUT,"OpenGL Build Touch v1.5\n\nWritten by James Ferry\n\nCopyright \n Monday, 8 February 1999");
SetupSectorProc(hwndDlg);
// GETDIRLISTING
break;
case WM_HELP:
WinHelp(((LPHELPINFO) lParam)->hItemHandle, "openglbt.hlp",
HELP_WM_HELP, (DWORD) (LPSTR) aIds);
break;
case WM_CONTEXTMENU:
WinHelp((HWND) wParam, "openglbt.hlp", HELP_CONTEXTMENU,
(DWORD) (LPVOID) aIds);
break;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDOK:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
EndDialog(hwndDlg, wParam);
return FALSE;
case IDCURSECT:
FrontSingle(BLUE_INDEX);
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
CURSECT=GetDlgItemInt(hwndDlg,ID_SECTORNUM,NULL, TRUE);
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDADJACENTWALL:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL=GetDlgItemInt(hwndDlg,ID_WPOINT2,NULL, TRUE);
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDJOININGWALL:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL=GetDlgItemInt(hwndDlg,ID_WNEXTW,NULL, TRUE);
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDJOININGSECTOR:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontSingle(BLUE_INDEX);
CURSECT=GetDlgItemInt(hwndDlg,ID_WNEXTS,NULL, TRUE);
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDFIRSTWALL:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL=GetDlgItemInt(hwndDlg,ID_FIRSTWALL,NULL, TRUE);
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDCURRENTWALL:
FrontWall(BLUE_INDEX);
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
CURWALL=GetDlgItemInt(hwndDlg,ID_WNUM,NULL, TRUE);
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDCANCEL:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDNEXT:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontSingle(BLUE_INDEX);
CURSECT++;
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDLAST:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontSingle(BLUE_INDEX);
CURSECT--;
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDFNEXT:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontSingle(BLUE_INDEX);
CURSECT+=10;
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDFLAST:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontSingle(BLUE_INDEX);
CURSECT-=10;
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDWNEXT:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL++;
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDWLAST:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL--;
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDWFNEXT:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL+=10;
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case IDWFLAST:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
FrontWall(BLUE_INDEX);
CURWALL-=10;
if(CURWALL<0)CURWALL=numwalls-1;
else if(CURWALL>=numwalls)CURWALL=0;
SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
// case IDREFRESH:
// GETDIRLISTING
// break;
case IDNEWMAP:
if(MessageBox(NULL, "Are you sure that you wish to create a new map?","New Map", MB_YESNO)==IDYES)
{
numsprites=0;
CURSECT=numsectors=0;
CURWALL=numwalls=0;
sprintf(szFile,"untitled.map");
SetupSectorProc(hwndDlg);
}
break;
case IDNEWSECTOR:
// int numsectors,numwalls,numsprites;
CURSECT=numsectors;
numsectors++;
SetupSectorProc(hwndDlg);
break;
case IDNEWWALL:
// int numsectors,numwalls,numsprites;
CURWALL=numwalls;
numwalls++;
SetupSectorProc(hwndDlg);
break;
// HERE
case IDO_REPLACE:
DialogBox(hinst,
MAKEINTRESOURCE(DLG_TEST),
hwndDlg, (DLGPROC)ReplaceItemProc);
SetupSectorProc(hwndDlg);
//hinst hWnd
break;
case IDO_SEENINEAPPLY:
for(a=0;a<numsprites;a++)
if(sprite[a].xrepeat<=4 && sprite[a].picnum==1247)
if(!(sprite[a].cstat&32768))sprite[a].cstat+=32768;
MessageBox(NULL, "Non-visible C-9 sprites have been made invisible.", "Finished", MB_OK);
break;
case IDO_SEENINEREMOVE:
for(a=0;a<numsprites;a++)
if(sprite[a].xrepeat<=4 && sprite[a].picnum==1247)
if(sprite[a].cstat&32768)sprite[a].cstat-=32768;
MessageBox(NULL, "Invisible C-9 sprites have been made visible again.", "Finished",
MB_OK);
break;
case IDO_CRACKAPPLY:
if(MessageBox(NULL,"Do you wish to make all cracks invisible?\nOtherwise I will change only paletted (2 or greater) sprites.\nPalettes of 2 will create multiplayer variants.", "Hide cracks", MB_YESNO|MB_ICONQUESTION)==IDYES)
{
for(a=0;a<numsprites;a++)
if(sprite[a].picnum>=546 && sprite[a].picnum<=549)
if(!(sprite[a].cstat&32768))
{
sprite[a].cstat+=32768;
if(sprite[a].pal==2)sprite[a].pal=1;
}
MessageBox(NULL, "Cracks are now invisible.", "Finished", MB_OK);
}
else
{
for(a=0;a<numsprites;a++)
if(sprite[a].picnum>=546 && sprite[a].picnum<=549)
if(!(sprite[a].cstat&32768))
if(sprite[a].pal>1)
{
sprite[a].cstat+=32768;
if(sprite[a].pal==2)sprite[a].pal=1;
}
MessageBox(NULL, "Paletted cracks are now invisible.", "Finished", MB_OK);
}
break;
case IDO_CRACKREMOVE:
if(MessageBox(NULL,
"Do you wish to make invisible multiplayer cracks to palette 2?\nOtherwise they will remain as the standard multiplayer palette.", "Hide cracks", MB_YESNO|MB_ICONQUESTION)==IDYES)
{
for(a=0;a<numsprites;a++)
if(sprite[a].picnum>=546 && sprite[a].picnum<=549)
if(sprite[a].cstat&32768)
{
sprite[a].cstat-=32768;
if(sprite[a].pal==1)sprite[a].pal=2;
}
MessageBox(NULL, "Cracks are now visible and multiplayer cracks have palette 2.",
"Finished", MB_OK);
}
else
{
for(a=0;a<numsprites;a++)
if(sprite[a].picnum>=546 && sprite[a].picnum<=549)
if(sprite[a].cstat&32768)
sprite[a].cstat-=32768;
MessageBox(NULL, "Cracks are now visible again.", "Finished", MB_OK);
}
break;
case IDLOAD:
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetOpenFileName(&ofn)==TRUE)
{
// MessageBox(NULL, szFile,"Filename", MB_OK);
if(load()==0)
{
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
CURSECT=0;
CURWALL=sector[CURSECT].wallptr;
SetupSectorProc(hwndDlg);
}
else MessageBox(WindowFromDC(hDC), "Cannot open map!","Error While Loading",MB_OK);
}
break;
case IDSAVE:
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
//if(MessageBox(WindowFromDC(hDC), "Save?","Save Map",MB_YESNO)==IDYES)
save();
break;
case IDSAVEAS:
ofn.Flags = OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetSaveFileName(&ofn)==TRUE)
{
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
save();
}
else MessageBox(WindowFromDC(hDC), "Cannot save map!","Error While Saving",MB_OK);
break;
/*
SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
GetDlgItemText(hwndDlg,IDSAVENAME,szItemName,260);
sprintf(file,"%s.map",szItemName);
sprintf(szItemName,"Save as %s?",file);
if(MessageBox(WindowFromDC(hDC), szItemName,"Save Map",MB_YESNO)==IDYES)
save();
GETDIRLISTING
break;
*/
/* case IDPLAY:
/// playCDTrack(NULL, 1);
playCDTrack(1);
EndDialog(hwndDlg, wParam);
return TRUE;
*/
}
}
return FALSE;
}
void SetupSpriteProc(HWND hwndDlg)
{
if(info_enable)
SetDlgItemText(hwndDlg,IDC_ENABLE,"Disable NW III TC sprite information");
else
SetDlgItemText(hwndDlg,IDC_ENABLE,"Enable NW III TC sprite information");
SetDlgItemInt(hwndDlg,IDS_SPRITE,CURSPRITE,TRUE);
SetDlgItemInt(hwndDlg,IDS_X,sprite[CURSPRITE].x,TRUE);
SetDlgItemInt(hwndDlg,IDS_Y,sprite[CURSPRITE].y,TRUE);
SetDlgItemInt(hwndDlg,IDS_Z,sprite[CURSPRITE].z,TRUE);
SetDlgItemInt(hwndDlg,IDS_STATNUM,sprite[CURSPRITE].statnum,TRUE);
SetDlgItemInt(hwndDlg,IDS_PAL,sprite[CURSPRITE].pal,TRUE);
SetDlgItemInt(hwndDlg,IDS_SHADE,sprite[CURSPRITE].shade,TRUE);
SetDlgItemInt(hwndDlg,IDS_ANG,sprite[CURSPRITE].ang,TRUE);
SetDlgItemInt(hwndDlg,IDS_OWNER,sprite[CURSPRITE].owner,TRUE);
SetDlgItemInt(hwndDlg,IDS_SECTNUM,sprite[CURSPRITE].sectnum,TRUE);
SetDlgItemInt(hwndDlg,IDS_PICNUM,sprite[CURSPRITE].picnum,TRUE);
SetDlgItemInt(hwndDlg,IDS_CLIPDIST,sprite[CURSPRITE].clipdist,TRUE);
SetDlgItemInt(hwndDlg,IDS_EXTRA,sprite[CURSPRITE].extra,TRUE);
SetDlgItemInt(hwndDlg,IDS_LOTAG,sprite[CURSPRITE].lotag,TRUE);
SetDlgItemInt(hwndDlg,IDS_HITAG,sprite[CURSPRITE].hitag,TRUE);
SetDlgItemInt(hwndDlg,IDS_XVEL,sprite[CURSPRITE].xvel,TRUE);
SetDlgItemInt(hwndDlg,IDS_YVEL,sprite[CURSPRITE].yvel,TRUE);
SetDlgItemInt(hwndDlg,IDS_ZVEL,sprite[CURSPRITE].zvel,TRUE);
SetDlgItemInt(hwndDlg,IDS_XREP,sprite[CURSPRITE].xrepeat,TRUE);
SetDlgItemInt(hwndDlg,IDS_YREP,sprite[CURSPRITE].yrepeat,TRUE);
SetDlgItemInt(hwndDlg,IDS_XOFF,sprite[CURSPRITE].xoffset,TRUE);
SetDlgItemInt(hwndDlg,IDS_YOFF,sprite[CURSPRITE].yoffset,TRUE);
if(sprite[CURSPRITE].cstat&1)
CheckDlgButton(hwndDlg,IDS_BLOCK,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_BLOCK,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&2)
CheckDlgButton(hwndDlg,IDS_TRANS,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_TRANS,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&4)
CheckDlgButton(hwndDlg,IDS_XFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_XFLIP,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&8)
CheckDlgButton(hwndDlg,IDS_YFLIP,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_YFLIP,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&16 && !(sprite[CURSPRITE].cstat&32))
CheckDlgButton(hwndDlg,IDS_FACEWALLFLOOR,BST_CHECKED);
else if(!(sprite[CURSPRITE].cstat&16) && sprite[CURSPRITE].cstat&32)
CheckDlgButton(hwndDlg,IDS_FACEWALLFLOOR,BST_INDETERMINATE);
else if(sprite[CURSPRITE].cstat&16 && sprite[CURSPRITE].cstat&32)
CheckDlgButton(hwndDlg,IDS_FACEWALLFLOOR,BST_UNCHECKED);
else if(!(sprite[CURSPRITE].cstat&16) && !(sprite[CURSPRITE].cstat&32))
CheckDlgButton(hwndDlg,IDS_FACEWALLFLOOR,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&64)
CheckDlgButton(hwndDlg,IDS_ONESIDE,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_ONESIDE,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&128)
CheckDlgButton(hwndDlg,IDS_CENTRE,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_CENTRE,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&256)
CheckDlgButton(hwndDlg,IDS_HITSCAN,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_HITSCAN,BST_UNCHECKED);
if(sprite[CURSPRITE].cstat&512)
CheckDlgButton(hwndDlg,IDS_TRANSREV,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_TRANSREV,BST_UNCHECKED);
/*
if(sprite[CURSPRITE].cstat&1024)
if(sprite[CURSPRITE].cstat&2048)
if(sprite[CURSPRITE].cstat&4096)
if(sprite[CURSPRITE].cstat&8192)
if(sprite[CURSPRITE].cstat&16384)
*/
if(sprite[CURSPRITE].cstat&32768)
CheckDlgButton(hwndDlg,IDS_INVISIBLE,BST_CHECKED);
else
CheckDlgButton(hwndDlg,IDS_INVISIBLE,BST_UNCHECKED);
}
void SaveSpriteProc(HWND hwndDlg)
{
char *endptr;
sprite[CURSPRITE].statnum=GetDlgItemInt(hwndDlg,IDS_STATNUM,NULL,TRUE);
sprite[CURSPRITE].pal=GetDlgItemInt(hwndDlg,IDS_PAL,NULL,TRUE);
sprite[CURSPRITE].shade=GetDlgItemInt(hwndDlg,IDS_SHADE,NULL,TRUE);
sprite[CURSPRITE].ang=GetDlgItemInt(hwndDlg,IDS_ANG,NULL,TRUE);
sprite[CURSPRITE].owner=GetDlgItemInt(hwndDlg,IDS_OWNER,NULL,TRUE);
sprite[CURSPRITE].sectnum=GetDlgItemInt(hwndDlg,IDS_SECTNUM,NULL,TRUE);
sprite[CURSPRITE].picnum=GetDlgItemInt(hwndDlg,IDS_PICNUM,NULL,TRUE);
sprite[CURSPRITE].clipdist=GetDlgItemInt(hwndDlg,IDS_CLIPDIST,NULL,TRUE);
sprite[CURSPRITE].extra=GetDlgItemInt(hwndDlg,IDS_EXTRA,NULL,TRUE);
sprite[CURSPRITE].lotag=GetDlgItemInt(hwndDlg,IDS_LOTAG,NULL,TRUE);
sprite[CURSPRITE].hitag=GetDlgItemInt(hwndDlg,IDS_HITAG,NULL,TRUE);
sprite[CURSPRITE].xvel=GetDlgItemInt(hwndDlg,IDS_XVEL,NULL,TRUE);
sprite[CURSPRITE].yvel=GetDlgItemInt(hwndDlg,IDS_YVEL,NULL,TRUE);
sprite[CURSPRITE].zvel=GetDlgItemInt(hwndDlg,IDS_ZVEL,NULL,TRUE);
sprite[CURSPRITE].xrepeat=GetDlgItemInt(hwndDlg,IDS_XREP,NULL,TRUE);
sprite[CURSPRITE].yrepeat=GetDlgItemInt(hwndDlg,IDS_YREP,NULL,TRUE);
sprite[CURSPRITE].xoffset=GetDlgItemInt(hwndDlg,IDS_XOFF,NULL,TRUE);
sprite[CURSPRITE].yoffset=GetDlgItemInt(hwndDlg,IDS_YOFF,NULL,TRUE);
GetDlgItemText(hwndDlg,IDS_X,szItemName,260);
sprite[CURSPRITE].x = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,IDS_Y,szItemName,260);
sprite[CURSPRITE].y = strtol(szItemName, &endptr, 10);
GetDlgItemText(hwndDlg,IDS_Z,szItemName,260);
sprite[CURSPRITE].z = strtol(szItemName, &endptr, 10);
sprite[CURSPRITE].cstat=0;
if(IsDlgButtonChecked(hwndDlg,IDS_BLOCK)==BST_CHECKED)
sprite[CURSPRITE].cstat+=1;
if(IsDlgButtonChecked(hwndDlg,IDS_TRANS)==BST_CHECKED)
sprite[CURSPRITE].cstat+=2;
if(IsDlgButtonChecked(hwndDlg,IDS_XFLIP)==BST_CHECKED)
sprite[CURSPRITE].cstat+=4;
if(IsDlgButtonChecked(hwndDlg,IDS_YFLIP)==BST_CHECKED)
sprite[CURSPRITE].cstat+=8;
if(IsDlgButtonChecked(hwndDlg,IDS_ONESIDE)==BST_CHECKED)
sprite[CURSPRITE].cstat+=64;
if(IsDlgButtonChecked(hwndDlg,IDS_CENTRE)==BST_CHECKED)
sprite[CURSPRITE].cstat+=128;
if(IsDlgButtonChecked(hwndDlg,IDS_HITSCAN)==BST_CHECKED)
sprite[CURSPRITE].cstat+=256;
if(IsDlgButtonChecked(hwndDlg,IDS_TRANSREV)==BST_CHECKED)
sprite[CURSPRITE].cstat+=512;
if(IsDlgButtonChecked(hwndDlg,IDS_INVISIBLE)==BST_CHECKED)
sprite[CURSPRITE].cstat+=32768;
if(IsDlgButtonChecked(hwndDlg,IDS_FACEWALLFLOOR)==BST_CHECKED)
sprite[CURSPRITE].cstat+=16;
else if(IsDlgButtonChecked(hwndDlg,IDS_FACEWALLFLOOR)==BST_INDETERMINATE)
sprite[CURSPRITE].cstat+=32;
}
char path1[260];
char path2[260];
char path3[260];
//BOOL CALLBACK TestProc(hwndDlg, message, wParam, lParam)
//HWND hwndDlg;
//UINT message;
//WPARAM wParam;
BOOL CALLBACK TestProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
char teststring[128];
char c;
OPENFILENAME ofn;
ZeroMemory(&ofn, sizeof (OPENFILENAME));
ofn.lStructSize = sizeof (OPENFILENAME);
ofn.hwndOwner = hwndDlg;
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
DWORD value;
if(message!=WM_INITDIALOG)
{
if(IsDlgButtonChecked(hwndDlg,IDC_VERBOSE)!=BST_CHECKED)
{
CheckDlgButton(hwndDlg,IDC_VERBOSE,BST_CHECKED);
SetDlgItemText(hwndDlg,IDC_STATUS,"Optimising without verbose checked is pretty much suicidal.");
}
if(IsDlgButtonChecked(hwndDlg,IDC_CHECKLOG)!=BST_UNCHECKED)
{
CheckDlgButton(hwndDlg,IDC_CHECKLOG,BST_UNCHECKED);
SetDlgItemText(hwndDlg,IDC_STATUS,"Logging has not been enabled as yet.");
}
}
switch (message)
{
case WM_INITDIALOG:
CheckDlgButton(hwndDlg,IDC_VERBOSE,BST_CHECKED);
break;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDC_BORIG:
ofn.lpstrFile = path1;
ofn.nMaxFile = sizeof (path1);
ofn.lpstrFilter = "Con files\0*.CON\0All\0*.*\0";
ofn.lpstrDefExt= "CON\0";
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST;
if (GetOpenFileName(&ofn)==TRUE)
SetDlgItemText(hwndDlg,IDC_ORIG,path1);
return FALSE;
case IDC_BOPTIM:
ofn.lpstrFile = path2;
ofn.nMaxFile = sizeof (path2);
ofn.lpstrFilter = "Con files\0*.CON\0All\0*.*\0";
ofn.lpstrDefExt= "CON\0";
ofn.Flags = OFN_PATHMUSTEXIST | OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetSaveFileName(&ofn)==TRUE)
SetDlgItemText(hwndDlg,IDC_OPTIM,path2);
return FALSE;
case IDC_BLOG:
ofn.lpstrFile = path3;
ofn.nMaxFile = sizeof (path3);
ofn.lpstrFilter = "Log files\0*.LOG\0Text files\0*.TXT\0All\0*.*\0";
ofn.lpstrDefExt= "LOG\0";
ofn.Flags = OFN_PATHMUSTEXIST | OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetSaveFileName(&ofn)==TRUE)
SetDlgItemText(hwndDlg,IDC_LOG,path3);
return FALSE;
case IDOK:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDC_START:
if(MessageBox(NULL,
"Just to let you know:\nThis program will not update the screen, except for the status window.\nThere is also no way to cancel (except, of coarse, Ctrl-alt-del)"
, "Inportant message", MB_OKCANCEL)==IDCANCEL)return FALSE;
GetDlgItemText(hwndDlg,IDC_ORIG,path1,256);
GetDlgItemText(hwndDlg,IDC_OPTIM,path2,256);
GetDlgItemText(hwndDlg,IDC_LOG,path3,256);
/*
sprintf(teststring,"%s\n%s\n%s\nVerbose: %i\nLoged: %i",
path1,path2,path3,
IsDlgButtonChecked(hwndDlg,IDC_VERBOSE)==BST_CHECKED?1:0,
IsDlgButtonChecked(hwndDlg,IDC_CHECKLOG)==BST_CHECKED?1:0);
MessageBox(NULL, teststring, "Feedback", MB_OK);
*/
SetDlgItemText(hwndDlg,IDC_STATUS,"Opening main file");
lastinclude=0;
array_size=0;
fnsplit(path1,driv1,dir1,name1,ext1);
if((in=fopen(path1,"rb"))==NULL)
{
MessageBox(NULL, "Can't open input file", "Feedback", MB_OK);
return FALSE;
}
fseek(in,0,2);
array_size=ftell(in);
fseek(in,0,0);
fread(bigarray,array_size,1,in);
fclose(in);
if((out=fopen(path2,"wb"))==NULL)
{
MessageBox(NULL, "Can't open output file", "Feedback", MB_OK);
return FALSE;
}
remove_comments(hwndDlg);
c=1;
while(c==1)
{
c=insert_includes(hwndDlg);
if(c==1)remove_comments(hwndDlg);
else if(c==3)return FALSE;
}
while(change_defs(hwndDlg));
remove_deadspace(hwndDlg);
remove_deadspace2(hwndDlg);
// remove_deadspace(hwndDlg);
fwrite(bigarray,array_size,1,out);
fclose(out);
SetDlgItemText(hwndDlg,IDC_STATUS,"Writing output to file");
SetDlgItemText(hwndDlg,IDC_STATUS,"Idle");
return FALSE;
}
break;
}
return FALSE;
}
void NewWorldProc(HWND hwndDlg)
{
//here2
char repstring[2048];
char repstring2[80];
char reptitle[80];
sprintf(reptitle,"No information");
sprintf(repstring,"");
if(sprite[CURSPRITE].lotag==10)
sprintf(repstring2,"Door auto closes in %i seconds (hitag %i)",div(sprite[CURSPRITE].hitag,32).quot,sprite[CURSPRITE].hitag);
if(sprite[CURSPRITE].picnum==2200 && info_enable)
{
sprintf(repstring,"\
pal 10 - Assault rifle\r\n\
pal 11 - Shells\r\n\
pal 12 - Grenades\r\n\
pal 13 - Lascannon\r\n\
pal 14 - Battery\r\n\
pal 15 - Clip\r\n\
pal 16 - Flamethrower\r\n\
pal 17 - Pipebombs\r\n\
pal 18 - Armour");
sprintf(reptitle,"Purchase (2200) - %s",
sprite[CURSPRITE].pal==10?"Assault rifle":
sprite[CURSPRITE].pal==11?"Shells":
sprite[CURSPRITE].pal==12?"Grenades":
sprite[CURSPRITE].pal==13?"Lascannon":
sprite[CURSPRITE].pal==14?"Battery":
sprite[CURSPRITE].pal==15?"Clip":
sprite[CURSPRITE].pal==16?"Flamethrower":
sprite[CURSPRITE].pal==17?"Pipebombs":
sprite[CURSPRITE].pal==18?"Armour":
"Invalid palette"
);}
else
if(sprite[CURSPRITE].picnum==23 && info_enable)
sprintf(reptitle,"Credit Clip (23)");
else
if(sprite[CURSPRITE].picnum==489 && info_enable)
{
sprintf(reptitle,"People (489)%s",
sprite[CURSPRITE].pal==9?" - Operative (flame thrower)":
sprite[CURSPRITE].pal==10?" - Personnel acquistion target":
sprite[CURSPRITE].pal==13?" - Operative (assault rifle)":
sprite[CURSPRITE].pal==14?" - Operative (pistol)":
" - Civilian"
);
sprintf(repstring,"\
pal 9 - Operative (flame thrower)\r\n\
pal 10 - Personnel acquisition target\r\n\
pal 13 - Operative (assault rifle)\r\n\
pal 14 - Operative (pistol)\r\n\
other - Civilian");}
else
if(sprite[CURSPRITE].picnum==1680 && info_enable)
{
sprintf(reptitle,"Delayed person (1680) - %s",
sprite[CURSPRITE].pal==14?"Operative (pistol)":
"Non-uniformed (pistol)"
);
sprintf(repstring,"\
pal 14 - Operative (pistol)\r\n\
other - Non-uniformed operative\r\n\nnote: un-uniformed operatives carry pistols and do not drop ammunition and weaponry");}
else
if(sprite[CURSPRITE].picnum==1715 && info_enable)
{
sprintf(reptitle,"Delayed person (1715) - %s",
sprite[CURSPRITE].pal==13?"Operative (assault rifle)":
sprite[CURSPRITE].pal==9?"Operative (flame thrower)":
"Non-uniformed (assault rifle)"
);
sprintf(repstring,"\
pal 13 - Operative (assault rifle)\r\n\
pal 9 - Operative (flame thrower)\r\n\
other - Non-uniformed operative\r\n\nnote: un-uniformed operatives carry assault rifles and do not drop ammunition, weaponry and access cards.\n\rUniformed operatives carry access cards.");}
else
if(sprite[CURSPRITE].picnum==487 && info_enable)
{
sprintf(reptitle,"Panel (487) - %s",
sprite[CURSPRITE].pal==2?
sector[sprite[CURSPRITE].sectnum].ceilingstat&2&&
sector[sprite[CURSPRITE].sectnum].floorstat&2
?"\nSurface damaging - warning: do not use on gradient":
sprite[CURSPRITE].z==sector[sprite[CURSPRITE].sectnum].ceilingz&&
!sector[sprite[CURSPRITE].sectnum].ceilingstat&2
?"\nCeiling surface damaging":
sprite[CURSPRITE].z!=sector[sprite[CURSPRITE].sectnum].floorz&&
!sector[sprite[CURSPRITE].sectnum].floorstat&2
?"\nFloor surface damaging":
!sector[sprite[CURSPRITE].sectnum].ceilingstat&2&&
!sector[sprite[CURSPRITE].sectnum].floorstat&2
?"\nSurface damaging - warning: appears to far from surface":
"\nSurface damaging - warning: on a gradient or to far from surface"
:
sprite[CURSPRITE].pal==0?"\nWall damaging":
sprite[CURSPRITE].pal==10?"Ladder":
sprite[CURSPRITE].pal==11?"Blue flag*":
sprite[CURSPRITE].pal==12?"Damagable wall panel":
sprite[CURSPRITE].pal==13?"Red flag*":
sprite[CURSPRITE].pal==14?"Blue team*":
sprite[CURSPRITE].pal==15?"Red team*":
"Invalid palette");
sprintf(repstring,"\
pal 0 - Wall damaging - damaged by area of effect weapons\r\n\
pal 2 - Surface damaging (floor and ceiling) - damaged by area of effect weapons\r\n\
pal 10 - Ladder\r\n\
pal 11 - Blue flag*\r\n\
pal 12 - Damagable wall panel\r\n\
pal 13 - Red flag*\r\n\
pal 14 - Blue team*\r\n\
pal 15 - Red team*\r\n\r\n\
(*) These are used for capture the flag maps." );
}
else
if(sprite[CURSPRITE].picnum==3400 && info_enable)
{
sprintf(reptitle,"Glass (3400) - %s",
sprite[CURSPRITE].pal==2?"Sugar glass":
sprite[CURSPRITE].pal==10?"Glass (normal reflection)":
sprite[CURSPRITE].pal==11?"Glass (strong reflection)":
"Invalid palette");
sprintf(repstring,"\
pal 2 - Sugar glass\r\n\
pal 10 - Glass (normal reflection)\r\n\
pal 11 - Glass (strong reflection)");
}
else if(sprite[CURSPRITE].picnum==51 && info_enable)
sprintf(reptitle,"Equipment acquisition target (51)");
else if(sprite[CURSPRITE].picnum==52 && info_enable)
sprintf(reptitle,"Sick bay (52)");
else if(sprite[CURSPRITE].picnum==130)
sprintf(reptitle,"Access lock (130) - locked");
else if(sprite[CURSPRITE].picnum==131)
sprintf(reptitle,"Access lock (131) - access");
else if(sprite[CURSPRITE].picnum==132)
sprintf(reptitle,"Switch (132) - off (red)");
else if(sprite[CURSPRITE].picnum==133)
sprintf(reptitle,"Switch (133) - on (green)");
else if(sprite[CURSPRITE].picnum==134)
sprintf(reptitle,"Switch (134) - off (red)");
else if(sprite[CURSPRITE].picnum==135)
sprintf(reptitle,"Switch (135) - on (green)");
else if(sprite[CURSPRITE].picnum==136)
sprintf(reptitle,"Switch (136) - off (red)");
else if(sprite[CURSPRITE].picnum==137)
sprintf(reptitle,"Switch (137) - on (green)");
else if(sprite[CURSPRITE].picnum==138)
sprintf(reptitle,"Switch (138) - off (red)");
else if(sprite[CURSPRITE].picnum==139)
sprintf(reptitle,"Switch (139) - on (green)");
else if(sprite[CURSPRITE].picnum==140)
sprintf(reptitle,"Switch (140) - off (red)");
else if(sprite[CURSPRITE].picnum==141)
sprintf(reptitle,"Switch (141) - on (green)");
else if(sprite[CURSPRITE].picnum==142)
sprintf(reptitle,"End level (142)");
else if(sprite[CURSPRITE].picnum==146)
sprintf(reptitle,"Multiple position switch (146) - position 4");
else if(sprite[CURSPRITE].picnum==147)
sprintf(reptitle,"Multiple position switch (147) - position 1");
else if(sprite[CURSPRITE].picnum==148)
sprintf(reptitle,"Multiple position switch (148) - position 2");
else if(sprite[CURSPRITE].picnum==149)
sprintf(reptitle,"Multiple position switch (149) - position 3");
else if(sprite[CURSPRITE].picnum==162)
sprintf(reptitle,"Switch (162) - off (red)");
else if(sprite[CURSPRITE].picnum==163)
sprintf(reptitle,"Switch (163) - on (green)");
else if(sprite[CURSPRITE].picnum==164)
sprintf(reptitle,"Switch (164) - off (red)");
else if(sprite[CURSPRITE].picnum==165)
sprintf(reptitle,"Switch (165) - on (green)");
else if(sprite[CURSPRITE].picnum==166)
sprintf(reptitle,"Switch (166) - off (red)");
else if(sprite[CURSPRITE].picnum==167)
sprintf(reptitle,"Switch (167) - on (green)");
else if(sprite[CURSPRITE].picnum==168)
sprintf(reptitle,"Switch (168) - off (red)");
else if(sprite[CURSPRITE].picnum==169)
sprintf(reptitle,"Switch (169) - on (green)");
else if(sprite[CURSPRITE].picnum==170)
sprintf(reptitle,"Access lock (170) - locked");
else if(sprite[CURSPRITE].picnum==171)
sprintf(reptitle,"Access lock (171) - access");
else if(sprite[CURSPRITE].picnum==407)
sprintf(reptitle,"Fan (407) - undamaged");
else if(sprite[CURSPRITE].picnum==411)
sprintf(reptitle,"Fan (411) - broken");
else if(sprite[CURSPRITE].picnum==712)
sprintf(reptitle,"Light switch (712) - switch is down");
else if(sprite[CURSPRITE].picnum==713)
sprintf(reptitle,"Light switch (713) - switch is up");
else if(sprite[CURSPRITE].picnum==860)
sprintf(reptitle,"Switch (860) - off (red)");
else if(sprite[CURSPRITE].picnum==861)
sprintf(reptitle,"Switch (861) - on (green)");
else if(sprite[CURSPRITE].picnum==862)
sprintf(reptitle,"Switch (862) - locked (red)");
else if(sprite[CURSPRITE].picnum==863)
sprintf(reptitle,"Switch (863) - open (green)");
else if(sprite[CURSPRITE].picnum==864)
sprintf(reptitle,"Switch (864) - off (red)");
else if(sprite[CURSPRITE].picnum==865)
sprintf(reptitle,"Switch (865) - on (green)");
else if(sprite[CURSPRITE].picnum==901)
sprintf(reptitle,"Ball (901)");
else if(sprite[CURSPRITE].picnum==902)
sprintf(reptitle,"Que ball (902)");
else if(sprite[CURSPRITE].picnum==903)
sprintf(reptitle,"Pocket (903)");
else if(sprite[CURSPRITE].picnum==908)
sprintf(reptitle,"Tree (908)");
else if(sprite[CURSPRITE].picnum==910)
sprintf(reptitle,"Tree (910)");
else if(sprite[CURSPRITE].picnum==911)
sprintf(reptitle,"Cactai (911)");
else if(sprite[CURSPRITE].picnum==916)
sprintf(reptitle,"Fire extinguisher (916)");
else if(sprite[CURSPRITE].picnum==939)
sprintf(reptitle,"Damage cactai (939)");
else if(sprite[CURSPRITE].picnum==940)
sprintf(reptitle,"Mine (940)");
else if(sprite[CURSPRITE].picnum==950)
sprintf(reptitle,"Broken fire hydrant (950)");
else if(sprite[CURSPRITE].picnum==952)
sprintf(reptitle,"Bullet hole (952)");
else if(sprite[CURSPRITE].picnum==981)
sprintf(reptitle,"Fire hydrant (981)");
else if(sprite[CURSPRITE].picnum==994)
sprintf(reptitle,"Pipe (994)");
else if(sprite[CURSPRITE].picnum==995)
sprintf(reptitle,"Pipe (995)");
else if(sprite[CURSPRITE].picnum==996)
sprintf(reptitle,"Pipe (996)");
else if(sprite[CURSPRITE].picnum==997)
sprintf(reptitle,"Pipe (997) - broken version of 996");
else if(sprite[CURSPRITE].picnum==1005)
sprintf(reptitle,"Pipe (1005) - broken version of 994");
else if(sprite[CURSPRITE].picnum==1260)
sprintf(reptitle,"Pipe (1260) - broken version of 995");
else if(sprite[CURSPRITE].picnum==1111)
sprintf(reptitle,"Switch (1111) - off/closed (normal)");
else if(sprite[CURSPRITE].picnum==1112)
sprintf(reptitle,"Switch (1112) - on/open (depressed)");
else if(sprite[CURSPRITE].picnum==1122)
sprintf(reptitle,"Switch (1122) - off (unlit)");
else if(sprite[CURSPRITE].picnum==1123)
sprintf(reptitle,"Switch (1123) - on (lit)");
else if(sprite[CURSPRITE].picnum==1142)
sprintf(reptitle,"Switch (1142) - off (unlit)");
else if(sprite[CURSPRITE].picnum==1143)
sprintf(reptitle,"Switch (1143) - on (lit/iris open)");
else if(sprite[CURSPRITE].picnum==1113)
sprintf(reptitle,"Vent (1113) - undamaged");
else if(sprite[CURSPRITE].picnum==1114)
sprintf(reptitle,"Vent (1114) - damaged");
else if(sprite[CURSPRITE].picnum==595)
sprintf(reptitle,"Vent (595) - undamaged");
else if(sprite[CURSPRITE].picnum==596)
sprintf(reptitle,"Vent (596) - damaged");
else if(sprite[CURSPRITE].picnum==341)
sprintf(reptitle,"Vent panel (341) - damaged");
else if(sprite[CURSPRITE].picnum==342)
sprintf(reptitle,"Vent panel (342) - un damaged");
else if(sprite[CURSPRITE].picnum==343)
sprintf(reptitle,"Vent panel (343) - slightly damaged");
else if(sprite[CURSPRITE].picnum==1222)
sprintf(reptitle,"Mechanical claw (1222)");
else if(sprite[CURSPRITE].picnum==1232)
sprintf(reptitle,"Garbage can (1232)");
else if(sprite[CURSPRITE].picnum==2566)
sprintf(reptitle,"Tripbomb (2566) - already set");
else if(sprite[CURSPRITE].picnum==621)
sprintf(reptitle,"Security camera (621)");
else if(sprite[CURSPRITE].picnum==499)
sprintf(reptitle,"Security screen (499)");
else if(sprite[CURSPRITE].picnum==502)
sprintf(reptitle,"Security screen (502)");
else if(sprite[CURSPRITE].picnum==71 && info_enable)
sprintf(reptitle,"Sign (71) - \"Flamethrower\"");
else if(sprite[CURSPRITE].picnum==72 && info_enable)
sprintf(reptitle,"Sign (72) - \"M16\"");
else if(sprite[CURSPRITE].picnum==73 && info_enable)
sprintf(reptitle,"Sign (73) - \"Grenades\"");
else if(sprite[CURSPRITE].picnum==74 && info_enable)
sprintf(reptitle,"Sign (74) - \"Shells\"");
else if(sprite[CURSPRITE].picnum==75 && info_enable)
sprintf(reptitle,"Sign (75) - \"Lascannon\"");
else if(sprite[CURSPRITE].picnum==76 && info_enable)
sprintf(reptitle,"Sign (76) - \"Battery\"");
else if(sprite[CURSPRITE].picnum==77 && info_enable)
sprintf(reptitle,"Sign (77) - \"Clip\"");
else if(sprite[CURSPRITE].picnum==78 && info_enable)
sprintf(reptitle,"Sign (78) - \"Armour\"");
else if(sprite[CURSPRITE].picnum==79 && info_enable)
sprintf(reptitle,"Sign (79) - \"Pipebombs\"");
else if(sprite[CURSPRITE].picnum==1247)
sprintf(reptitle,"C-9 canister (1247)");
else if(sprite[CURSPRITE].picnum==1312 && info_enable)
sprintf(reptitle,"Screen target (1312) - end of game");
else if(sprite[CURSPRITE].picnum==546)
sprintf(reptitle,"Crack 1 (546)");
else if(sprite[CURSPRITE].picnum==547)
sprintf(reptitle,"Crack 2 (547)");
else if(sprite[CURSPRITE].picnum==548)
sprintf(reptitle,"Crack 3 (548)");
else if(sprite[CURSPRITE].picnum==549)
sprintf(reptitle,"Crack 4 (549)");
else if(sprite[CURSPRITE].picnum==2)
sprintf(reptitle,"Activator (2)");
else if(sprite[CURSPRITE].picnum==3)
sprintf(reptitle,"Touchplate (3)");
else if(sprite[CURSPRITE].picnum==4)
sprintf(reptitle,"Activator locked (4)");
else if(sprite[CURSPRITE].picnum==5)
sprintf(reptitle,"Music and SFX (5)");
else if(sprite[CURSPRITE].picnum==6)
sprintf(reptitle,"Locator (6)");
else if(sprite[CURSPRITE].picnum==7)
sprintf(reptitle,"Cycler (7)");
else if(sprite[CURSPRITE].picnum==8)
sprintf(reptitle,"Master switch (8)");
else if(sprite[CURSPRITE].picnum==9 && info_enable)
sprintf(reptitle,"Respawn (9) - Respawn doesn't seem to work with NW III TC");
else if(sprite[CURSPRITE].picnum==9)
sprintf(reptitle,"Respawn (9)");
else if(sprite[CURSPRITE].picnum==10)
sprintf(reptitle,"GP Speed (10)");
else if(sprite[CURSPRITE].picnum==1405)
{
sprintf(reptitle,"A player start (1405) - %s",sprite[CURSPRITE].lotag?"Co-operative":"Dukematch");
sprintf(repstring,"lotag 1 - co-operative\r\nother - dukematch");
}
else if(sprite[CURSPRITE].picnum==55 && info_enable)
{
sprintf(reptitle,"Persuadatron (55)");
sprintf(repstring,"Used for personnel acquisition missions with sprite 489 (human) of pal 10 and sprite 60 (drop zone).");
}
else if(sprite[CURSPRITE].picnum==60 && info_enable)
{
sprintf(reptitle,"Personnel acquisition drop zone (60)");
sprintf(repstring,"Used with blue lock, with sprite 55 (drop zone) of pal 10 and sprite 60 (drop zone).");
}
else
if(sprite[CURSPRITE].picnum==1)
{
sprintf(repstring,"\
Lotags\r\n\
0 - Rotating sector\r\n\
1 - Pivot point for SE 0\r\n\
2 - Earthquake\r\n\
3 - Random lights after shot out\r\n\
4 - Random lights\r\n\
6 - Train\r\n\
7 - Transport (water with ST 1 and 2)\r\n\
8 - Up open door lights\r\n\
9 - Down open door lights\r\n\
10 - Door auto close (hitag=delay)\r\n\
11 - Rotate sector door (ST 23)\r\n\
12 - Light switch\r\n\
13 - C-9 explosion\r\n\
14 - Train car\r\n\
15 - Sliding door (ST 25)\r\n\
16 - Rotate reactor sector\r\n\
17 - Elevator transport (ST 15, SHT 1/0)\r\n\
19 - Shot touchplate ceiling down\r\n\
20 - Bridge (ST 27)\r\n\
21 - Drop floor (ST 28)\r\n\
22 - Prong (ST 29)\r\n\
24 - Convairbelt\r\n\
25 - Engine\r\n\
27 - Camera for playback\r\n\
29 - Float sector\r\n\
30 - Two way train (ST 31)\r\n\
31 - Floor rise\r\n\
32 - Ceiling lower\r\n\
33 - Earthquakes debris\r\n\
34 - Shooting sector");
sprintf(reptitle,"Sector effector (1) - %s",
sprite[CURSPRITE].lotag==0?"Rotating sector":
sprite[CURSPRITE].lotag==1?"Pivot point for SE 0":
sprite[CURSPRITE].lotag==2?"Earthquake":
sprite[CURSPRITE].lotag==3?"Random lights after shot out":
sprite[CURSPRITE].lotag==4?"Random lights":
sprite[CURSPRITE].lotag==6?"Train":
sprite[CURSPRITE].lotag==7&&sector[sprite[CURSPRITE].sectnum].lotag==1?"Water transport - above surface":
sprite[CURSPRITE].lotag==7&&sector[sprite[CURSPRITE].sectnum].lotag==2?"Water transport - below surface":
sprite[CURSPRITE].lotag==7?"Transport":
sprite[CURSPRITE].lotag==8?"Up open door lights":
sprite[CURSPRITE].lotag==9?"Down open door lights":
sprite[CURSPRITE].lotag==10?repstring2:
sprite[CURSPRITE].lotag==11&&sector[sprite[CURSPRITE].sectnum].lotag==23?"Rotate sector door":
sprite[CURSPRITE].lotag==11?"Rotate sector door - needs ST 23":
sprite[CURSPRITE].lotag==12?"Light switch":
sprite[CURSPRITE].lotag==13?"C-9 explosion":
sprite[CURSPRITE].lotag==14?"Train car":
sprite[CURSPRITE].lotag==15&&sector[sprite[CURSPRITE].sectnum].lotag==25?"Sliding door":
sprite[CURSPRITE].lotag==15?"Sliding door - needs ST 25":
sprite[CURSPRITE].lotag==16?"Rotate reactor sector":
sprite[CURSPRITE].lotag==17&&sector[sprite[CURSPRITE].sectnum].lotag==15&&sector[CURSECT].hitag==0?"Elevator transport - bottom floor":
sprite[CURSPRITE].lotag==17&&sector[sprite[CURSPRITE].sectnum].lotag==15&&sector[CURSECT].hitag==1?"Elevator transport - top floor":
sprite[CURSPRITE].lotag==17&&sector[sprite[CURSPRITE].sectnum].lotag==15?"Elevator transport - unknown hitag":
sprite[CURSPRITE].lotag==17?"Elevator transport - needs ST 15":
sprite[CURSPRITE].lotag==19?"Shot touchplate ceiling down":
sprite[CURSPRITE].lotag==20&&sector[sprite[CURSPRITE].sectnum].lotag==27?"Bridge":
sprite[CURSPRITE].lotag==20?"Bridge - needs ST 27":
sprite[CURSPRITE].lotag==21&&sector[sprite[CURSPRITE].sectnum].lotag==28?"Drop floor":
sprite[CURSPRITE].lotag==21?"Drop floor - needs ST 28":
sprite[CURSPRITE].lotag==22&&sector[sprite[CURSPRITE].sectnum].lotag==29?"Prong":
sprite[CURSPRITE].lotag==22?"Prong - needs ST 29":
sprite[CURSPRITE].lotag==24?"Convairbelt":
sprite[CURSPRITE].lotag==25?"Engine":
sprite[CURSPRITE].lotag==27?"Camera for playback":
sprite[CURSPRITE].lotag==29?"Float sector":
sprite[CURSPRITE].lotag==30&&sector[sprite[CURSPRITE].sectnum].lotag==31?"Two way train":
sprite[CURSPRITE].lotag==30?"Two way train - needs ST 31":
sprite[CURSPRITE].lotag==31?"Floor rise":
sprite[CURSPRITE].lotag==32?"Ceiling lower":
sprite[CURSPRITE].lotag==33?"Earthquakes debris":
sprite[CURSPRITE].lotag==34?"Shooting sector":
"Unknown"
);}
// else
// {
// sprintf(reptitle,"No information");
// sprintf(repstring,"");
// }
SetDlgItemText(hwndDlg,IDC_INFOTITLE,reptitle);
SetDlgItemText(hwndDlg,IDC_INFOBOX,repstring);
if(auto_update){
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
}
}
char EXTERNAL_DUKE[80]="duke3d.exe";
char EXTERNAL_SETUP[80]="setup.exe";
char EXTERNAL_BUILD[80]="build.exe";
char EXTERNAL_EDITART[80]="editart.exe";
char EXTERNAL_SETUPFILE[80]="duke3d.cfg";
long int EXTERNAL_PLAYERS=1;
BOOL CALLBACK ExternalProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
/*
BOOL CALLBACK ExternalProc(hwndDlg, message, wParam, lParam)
HWND hwndDlg;
UINT message;
WPARAM wParam;
//LPARAM lParam;
*/
{
static DWORD aIds[] = {
IDC_N_DUKE, IDH_E_N_DUKE,
IDC_N_SETUP, IDH_E_N_SETUP,
IDC_N_BUILD, IDH_E_N_BUILD,
IDC_N_EDITART, IDH_E_N_EDITART,
IDC_N_SETUPFILE, IDH_E_N_CONFIG,
IDC_N_PLAYERS, IDH_E_N_PLAYERS,
IDC_RUN_DUKE, IDH_E_S_DUKE,
IDC_RUN_SETUP, IDH_E_S_SETUP,
IDC_RUN_BUILD, IDH_E_S_BUILD,
IDC_RUN_EDITART, IDH_E_S_EDITART,
0,0
};
char repstring[80]="";
switch (message)
{
case WM_HELP:
WinHelp(((LPHELPINFO) lParam)->hItemHandle, "openglbt.hlp",
HELP_WM_HELP, (DWORD) (LPSTR) aIds);
break;
case WM_CONTEXTMENU:
WinHelp((HWND) wParam, "openglbt.hlp", HELP_CONTEXTMENU,
(DWORD) (LPVOID) aIds);
break;
case WM_INITDIALOG:
SetDlgItemText(hwndDlg,IDC_N_DUKE,EXTERNAL_DUKE);
SetDlgItemText(hwndDlg,IDC_N_SETUP,EXTERNAL_SETUP);
SetDlgItemText(hwndDlg,IDC_N_BUILD,EXTERNAL_BUILD);
SetDlgItemText(hwndDlg,IDC_N_EDITART,EXTERNAL_EDITART);
SetDlgItemText(hwndDlg,IDC_N_SETUPFILE,EXTERNAL_SETUPFILE);
SetDlgItemInt(hwndDlg,IDC_N_PLAYERS,EXTERNAL_PLAYERS,TRUE);
break;
case WM_CLOSE:
GetDlgItemText(hwndDlg,IDC_N_DUKE,EXTERNAL_DUKE,80);
GetDlgItemText(hwndDlg,IDC_N_SETUPFILE,EXTERNAL_SETUPFILE,80);
GetDlgItemText(hwndDlg,IDC_N_BUILD,EXTERNAL_BUILD,80);
GetDlgItemText(hwndDlg,IDC_N_EDITART,EXTERNAL_EDITART,80);
EXTERNAL_PLAYERS=GetDlgItemInt(hwndDlg,IDC_N_PLAYERS,NULL,TRUE);
if(EXTERNAL_PLAYERS<1)
EXTERNAL_PLAYERS=1;
else if(EXTERNAL_PLAYERS>8)
EXTERNAL_PLAYERS=8;
EndDialog(hwndDlg, wParam);
return FALSE;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDC_RUN_DUKE:
GetDlgItemText(hwndDlg,IDC_N_DUKE,EXTERNAL_DUKE,80);
GetDlgItemText(hwndDlg,IDC_N_SETUPFILE,EXTERNAL_SETUPFILE,80);
EXTERNAL_PLAYERS=GetDlgItemInt(hwndDlg,IDC_N_PLAYERS,NULL,TRUE);
if(EXTERNAL_PLAYERS<1)
{
EXTERNAL_PLAYERS=1;
SetDlgItemInt(hwndDlg,IDC_N_PLAYERS,EXTERNAL_PLAYERS,TRUE);
}
else if(EXTERNAL_PLAYERS>8)
{
EXTERNAL_PLAYERS=8;
SetDlgItemInt(hwndDlg,IDC_N_PLAYERS,EXTERNAL_PLAYERS,TRUE);
}
if(EXTERNAL_PLAYERS==1)
{
sprintf(repstring,"%s -map %s SETUPFILE %s",EXTERNAL_DUKE,szFile,EXTERNAL_SETUPFILE)
;
system(repstring);
} else
{
sprintf(repstring,"%s -map %s /q%li SETUPFILE %s",EXTERNAL_DUKE,szFile,EXTERNAL_PLAYERS,EXTERNAL_SETUPFILE);
system(repstring);
}
break;
case IDC_RUN_SETUP:
GetDlgItemText(hwndDlg,IDC_N_SETUPFILE,EXTERNAL_SETUPFILE,80);
GetDlgItemText(hwndDlg,IDC_N_BUILD,EXTERNAL_BUILD,80);
sprintf(repstring,"%s SETUPFILE %s",EXTERNAL_SETUP,EXTERNAL_SETUPFILE);
system(repstring);
break;
case IDC_RUN_BUILD:
GetDlgItemText(hwndDlg,IDC_N_BUILD,EXTERNAL_BUILD,80);
sprintf(repstring,"%s %s",EXTERNAL_BUILD,szFile);
system(repstring);
break;
case IDC_RUN_EDITART:
GetDlgItemText(hwndDlg,IDC_N_EDITART,EXTERNAL_EDITART,80);
sprintf(repstring,"%s",EXTERNAL_EDITART);
system(repstring);
break;
case IDOK:
GetDlgItemText(hwndDlg,IDC_N_DUKE,EXTERNAL_DUKE,80);
GetDlgItemText(hwndDlg,IDC_N_SETUPFILE,EXTERNAL_SETUPFILE,80);
GetDlgItemText(hwndDlg,IDC_N_BUILD,EXTERNAL_BUILD,80);
GetDlgItemText(hwndDlg,IDC_N_EDITART,EXTERNAL_EDITART,80);
EXTERNAL_PLAYERS=GetDlgItemInt(hwndDlg,IDC_N_PLAYERS,NULL,TRUE);
if(EXTERNAL_PLAYERS<1)
EXTERNAL_PLAYERS=1;
else if(EXTERNAL_PLAYERS>8)
EXTERNAL_PLAYERS=8;
EndDialog(hwndDlg, wParam);
return FALSE;
}
break;
}
return FALSE;
}
BOOL CALLBACK SpriteItemProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
/*
BOOL CALLBACK SpriteItemProc(hwndDlg, message, wParam, lParam)
HWND hwndDlg;
UINT message;
WPARAM wParam;
//LPARAM lParam;
*/
{
static DWORD aIds[] = {
IDS_X, IDH_S_X,
IDS_Y, IDH_S_Y,
IDS_Z, IDH_S_Z,
IDS_BLOCK, IDH_S_BLOCKING,
IDS_TRANS, IDH_S_TRANSLUCENT,
IDS_TRANSREV, IDH_S_REVERSING,
IDS_HITSCAN, IDH_S_HITSCAN,
IDS_XFLIP, IDH_S_X_FLIP,
IDS_YFLIP, IDH_S_Y_FLIP,
IDS_FACEWALLFLOOR, IDH_S_FACE,
IDS_ONESIDE, IDH_S_SINGLE,
IDS_CENTRE, IDH_S_CENTRE,
IDS_INVISIBLE, IDH_S_INVISIBLE,
IDS_PICNUM, IDH_S_PICNUM,
IDS_SHADE, IDH_S_SHADE,
IDS_PAL, IDH_S_PAL,
IDS_CLIPDIST, IDH_S_CLIPDIST,
IDS_XREP, IDH_S_XREPEAT,
IDS_YREP, IDH_S_YREPEAT,
IDS_XOFF, IDH_S_XOFFSET,
IDS_YOFF, IDH_S_YOFFSET,
IDS_SECTNUM, IDH_S_SECTNUM,
IDS_AUTOUPDATE, IDH_S_AUTO,
IDS_UPDATE, IDH_S_UPDATE,
IDS_LAST, IDH_S_LAST,
IDS_NEXT, IDH_S_NEXT,
IDS_FLAST, IDH_S__LAST,
IDS_FNEXT, IDH_S__NEXT,
IDS_CSPRITE, IDH_S_SPRITENUM_SEL,
IDS_SPRITE, IDH_S_SPRITENUM,
IDC_ENABLE, IDH_S_ENABLE,
IDC_INFOTITLE, IDH_S_INFO,
IDC_INFOBOX, IDH_S_INFOBOX,
IDS_STATNUM, IDH_S_STATNUM,
IDS_ANG, IDH_S_ANG,
IDS_XVEL, IDH_S_XVEL,
IDS_YVEL, IDH_S_YVEL,
IDS_ZVEL, IDH_S_ZVEL,
IDS_OWNER, IDH_S_OWNER,
IDS_EXTRA, IDH_S_EXTRA,
IDS_LOTAG, IDH_S_LOTAG,
IDS_HITAG, IDH_S_HITAG,
IDS_CSECTNUM, IDH_S_SECTNUMSEL,
0,0
};
switch (message)
{
case WM_HELP:
WinHelp(((LPHELPINFO) lParam)->hItemHandle, "openglbt.hlp", HELP_WM_HELP, (DWORD) (LPSTR) aIds);
break;
case WM_CONTEXTMENU:
WinHelp((HWND) wParam, "openglbt.hlp", HELP_CONTEXTMENU, (DWORD) (LPVOID) aIds);
break;
case WM_INITDIALOG:
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
if(auto_update)
SetDlgItemText(hwndDlg,IDS_AUTOUPDATE,"Disable auto update");
else
SetDlgItemText(hwndDlg,IDS_AUTOUPDATE,"Enable auto update");
// GETDIRLISTING
break;
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDC_ENABLE:
if(info_enable)
{SetDlgItemText(hwndDlg,IDC_ENABLE,"Enable NW III TC sprite information");info_enable=0;}
else
{SetDlgItemText(hwndDlg,IDC_ENABLE,"Disable NW III TC sprite information");info_enable=1;}
NewWorldProc(hwndDlg);
break;
case IDOK:
SaveSpriteProc(hwndDlg);
EndDialog(hwndDlg, wParam);
return FALSE;
case IDCANCEL:
EndDialog(hwndDlg, wParam);
return FALSE;
case IDS_CSPRITE:
CURSPRITE=GetDlgItemInt(hwndDlg,IDS_SPRITE,NULL, TRUE);
if(CURSPRITE<0)CURSPRITE=numsprites-1;
else if(CURSPRITE>=numsprites)CURSPRITE=0;
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
break;
case IDS_UPDATE:
Right();Top();Front();
SwapBuffers(hDC);
break;
case IDS_AUTOUPDATE:
if(auto_update)
{auto_update=0;SetDlgItemText(hwndDlg,IDS_AUTOUPDATE,"Enable auto update");}
else
{auto_update=1;SetDlgItemText(hwndDlg,IDS_AUTOUPDATE,"Disable auto update");}
break;
case IDS_NEXT:
SaveSpriteProc(hwndDlg);
CURSPRITE++;
if(CURSPRITE>=numsprites)CURSPRITE=0;
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
break;
case IDS_LAST:
SaveSpriteProc(hwndDlg);
CURSPRITE--;
if(CURSPRITE<0)CURSPRITE=numsprites-1;
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
break;
case IDS_FNEXT:
SaveSpriteProc(hwndDlg);
CURSPRITE+=10;
if(CURSPRITE>=numsprites)CURSPRITE=0;
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
break;
case IDS_FLAST:
SaveSpriteProc(hwndDlg);
CURSPRITE-=10;
if(CURSPRITE<0)CURSPRITE=numsprites-1;
SetupSpriteProc(hwndDlg);
NewWorldProc(hwndDlg);
break;
// SaveSectorProc(hwndDlg);SaveWallProc(hwndDlg);
// IDC_RADIOBUTTON1
case IDS_CSECTNUM:
FrontSingle(BLUE_INDEX);
SaveSpriteProc(hwndDlg);
CURSECT=GetDlgItemInt(hwndDlg,IDS_SECTNUM,NULL, TRUE);
if(CURSECT<0)CURSECT=numsectors-1;
else if(CURSECT>=numsectors)CURSECT=0;
// SetupSectorProc(hwndDlg);
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
}
break;
}
return FALSE;
}
BOOL CALLBACK AboutProc(HWND hwndDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
switch (message)
{
case WM_COMMAND:
switch (LOWORD(wParam))
{
case IDOK:
SaveSpriteProc(hwndDlg);
EndDialog(hwndDlg, wParam);
return FALSE;
case IDCANCEL:
EndDialog(hwndDlg, wParam);
return FALSE;
}
break;
}
return FALSE;
}
void help(void)
{
MessageBox(NULL, "\
This version of OpenGL Build Touch only has a brief help file so hence this prologue.\n\n\
Please note:\n\
Please use a resolution of 1024x800 or greater as some of the dialogue boxes are rather large.\n\
n\
Controls (these buttons are for the main screen only, which is the one with the map)\n\
escape\tquit\n\
F1\tthis information screen\n\
1\ttoggle one sided wall verteces\n\
2\t2d mode\n\
3\t3d mode\n\
4\ttoggle wall verteces\n\
5\topens sprite editing window\n\
6\tprevious sprite\n\
7\tnext sprite\n\
8\tprevious sector\n\
9\tnext sector\n\
0/o\topens main editing window (walls, sectors and file management)\n\
-=_\tprevious sprite\n\
=/+\tnext sprite\n\
e\topens the external program manager\n\
up\tscrolls map up\n\
down\tscrolls map down\n\
left\tscrolls map left\n\
right\tscrolls map right\n\
\nA menu has been added, as well as group file extraction. This can be accessed via the menu. There is context help in the editing screens.", "Information", MB_ICONINFORMATION|MB_OK);
}
void redraw(void)
{
Right();
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Top();
SwapBuffers(hDC);
}
//LRESULT APIENTRY
//WndProc(
LONG WINAPI WndProc (
HWND hWnd,
UINT message,
WPARAM wParam,
LPARAM lParam)
{
///*
OPENFILENAME ofn; // common dialog box structure
ZeroMemory(&ofn, sizeof (OPENFILENAME));
ofn.lStructSize = sizeof (OPENFILENAME);
ofn.hwndOwner = hWnd;
ofn.nFilterIndex = 1;
ofn.lpstrFileTitle = NULL;
ofn.nMaxFileTitle = 0;
ofn.lpstrInitialDir = NULL;
ofn.lpstrFile = szFile;
ofn.nMaxFile = sizeof (szFile);
ofn.lpstrFilter = "Maps\0*.MAP\0All\0*.*\0";
ofn.lpstrDefExt= "MAP\0";
switch (message) {
case WM_COMMAND:
switch (LOWORD(wParam))
{
case CM_WallSect:
DialogBox(hinst,
MAKEINTRESOURCE(DLG_DELETEITEM),
hWnd, (DLGPROC)DeleteItemProc);
break;
case CM_Sprite:
DialogBox(hinst,
MAKEINTRESOURCE(DLG_SPRITE),
hWnd, (DLGPROC)SpriteItemProc);
break;
case CM_Test:
DialogBox(hinst,
MAKEINTRESOURCE(DLG_TEST),
hWnd, (DLGPROC)ReplaceItemProc);
break;
case CM_OPTIMISE:
DialogBox(hinst,
MAKEINTRESOURCE(TEST),
hWnd, (DLGPROC)TestProc);
break;
case CM_External:
DialogBox(hinst,
MAKEINTRESOURCE(DLG_EXTERNAL),
hWnd, (DLGPROC)ExternalProc);
break;
case CM_Patch:
DialogBox(hinst,
MAKEINTRESOURCE(STUB),
hWnd, (DLGPROC)StubProc);
break;
case CM_Group:
/*
ofn.lpstrFile = filename;
ofn.nMaxFile = sizeof(filename);
ofn.lpstrFilter = "Group files\0*.GRP\0All\0*.*\0";
ofn.lpstrDefExt= "GRP\0";
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetOpenFileName(&ofn)==TRUE)
{
DialogBox(hinst,
MAKEINTRESOURCE(DLG_GROUP),
hWnd, (DLGPROC)GroupProc);
}
*/
DialogBox(hinst,
MAKEINTRESOURCE(DLG_GROUP),
hWnd, (DLGPROC)GroupProc);
break;
case CM_EXIT:
DestroyWindow(hWnd);
break;
case CM_ABOUT:
DialogBox(hinst,
MAKEINTRESOURCE(ABOUT),
hWnd, (DLGPROC)AboutProc);
// help();
break;
case IDM_NEW:
if(MessageBox(NULL, "Are you sure that you wish to create a new map?","New Map", MB_YESNO)==IDYES)
{
numsprites=0;
CURSECT=numsectors=0;
CURWALL=numwalls=0;
sprintf(szFile,"untitled.map");
redraw();
}
break;
case IDM_HELP:
WinHelp(hWnd, "openglbt.hlp",
HELP_CONTENTS,0);
break;
case IDM_SAVE:
save();
break;
case IDM_SAVEAS:
ofn.lpstrFile = szFile;
ofn.nMaxFile = sizeof (szFile);
ofn.lpstrFilter = "Maps\0*.MAP\0All\0*.*\0";
ofn.lpstrDefExt= "MAP\0";
ofn.Flags = OFN_PATHMUSTEXIST|OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetSaveFileName(&ofn)==TRUE)
save();
else MessageBox(WindowFromDC(hDC), "Cannot save map!","Error While Saving",MB_OK);
break;
case IDM_OPEN:
ofn.lpstrFile = szFile;
ofn.nMaxFile = sizeof (szFile);
ofn.lpstrFilter = "Maps\0*.MAP\0All\0*.*\0";
ofn.lpstrDefExt= "MAP\0";
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetOpenFileName(&ofn)==TRUE)
{
if(load()==0)
{
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
CURSECT=0;
CURWALL=sector[CURSECT].wallptr;
}
else MessageBox(WindowFromDC(hDC), "Cannot open map!","Error While Loading",MB_OK);
}
break;
}
break;
case WM_CREATE:
/* initialize OpenGL rendering */
hDC = GetDC(hWnd);
// bSetupPixelFormat(hDC);
setupPalette(hDC);
hGLRC = wglCreateContext(hDC);
wglMakeCurrent(hDC, hGLRC);
init();
return 0;
case WM_DESTROY:
/* finish OpenGL rendering */
if (hGLRC) {
wglMakeCurrent(NULL, NULL);
wglDeleteContext(hGLRC);
}
if (hPalette) {
DeleteObject(hPalette);
}
ReleaseDC(hWnd, hDC);
PostQuitMessage(0);
return 0;
case WM_SIZE:
/* track window size changes */
// if (hGLRC) {
// winWidth = (int) LOWORD(lParam);
// winHeight = (int) HIWORD(lParam);
// resize();
// return 0;
// }
case WM_PALETTECHANGED:
/* realize palette if this is *not* the current window */
if (hGLRC && hPalette && (HWND) wParam != hWnd) {
UnrealizeObject(hPalette);
SelectPalette(hDC, hPalette, FALSE);
RealizePalette(hDC);
redraw();
break;
}
break;
case WM_QUERYNEWPALETTE:
/* realize palette if this is the current window */
if (hGLRC && hPalette) {
UnrealizeObject(hPalette);
SelectPalette(hDC, hPalette, FALSE);
RealizePalette(hDC);
redraw();
return TRUE;
}
break;
case WM_CHAR:
{
switch (wParam) {
case 'E':
case 'e':
DialogBox(hinst,
MAKEINTRESOURCE(DLG_EXTERNAL),
hWnd, (DLGPROC)ExternalProc);
break;
case '_':
case '-':
if(CURSPRITE==0)CURSPRITE=numsprites-1;
else CURSPRITE--;
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case '+':
case '=':
if(CURSPRITE>=numsprites-1)CURSPRITE=0;
CURSPRITE++;
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
}}
break;
case WM_KEYDOWN:
{
switch (wParam) {
case '1':
if(show_one_side3d)show_one_side3d=0;
else show_one_side3d=1;
redraw3d();
break;
case '2':
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Top();
Right();
SwapBuffers(hDC);
break;
case '3':
redraw3d();
break;
case '4':
if(show_wall3d)show_wall3d=0;
else show_wall3d=1;
redraw3d();
break;
case VK_LEFT:
longinc += 10.0F;
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Top();
// redraw();
SwapBuffers(hDC);
break;
case '8':
FrontSingle(BLUE_INDEX);
//FrontWall(BLUE_INDEX);
if(CURSECT==0)CURSECT=numsectors-1;
else CURSECT--;
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case '9':
FrontSingle(BLUE_INDEX);
//FrontWall(BLUE_INDEX);
if(CURSECT>=numsectors-1)CURSECT=0;
CURSECT++;
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case '6':
//FrontSingle(BLUE_INDEX);
FrontWall(BLUE_INDEX);
if(CURWALL==0)CURWALL=numwalls-1;
else CURWALL--;
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case '7':
//FrontSingle(BLUE_INDEX);
FrontWall(BLUE_INDEX);
if(CURWALL>=numwalls-1)CURWALL=0;
CURWALL++;
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
break;
case VK_RIGHT:
longinc -= 10.0F;
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Top();
// redraw();
SwapBuffers(hDC);
break;
case VK_UP:
latinc += 10.0F;
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Right();
// redraw();
SwapBuffers(hDC);
break;
case VK_DOWN:
latinc -= 10.0F;
Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
Right();
// redraw();
SwapBuffers(hDC);
break;
case VK_F1:
help();
break;
case VK_ESCAPE:
DestroyWindow(hWnd);
break;
case 'C':
DialogBox(hinst,
MAKEINTRESOURCE(STUB),
hWnd, (DLGPROC)StubProc);
break;
case 'O':
DialogBox(hinst,
MAKEINTRESOURCE(DLG_DELETEITEM),
hWnd, (DLGPROC)DeleteItemProc);
break;
case '0':
DialogBox(hinst,
MAKEINTRESOURCE(DLG_DELETEITEM),
hWnd, (DLGPROC)DeleteItemProc);
break;
case 'T':
// case 't':
DialogBox(hinst,
MAKEINTRESOURCE(TEST),
hWnd, (DLGPROC)TestProc);
break;
case '5':
DialogBox(hinst,
MAKEINTRESOURCE(DLG_SPRITE),
hWnd, (DLGPROC)SpriteItemProc);
break;
// default:
// break;
}
}
break;
/* case WM_MENUSELECT:
// switch(LOWORD(wParam))
// {
// case IDM_OPEN:
ofn.Flags = OFN_PATHMUSTEXIST | OFN_FILEMUSTEXIST |OFN_NOREADONLYRETURN|OFN_HIDEREADONLY;
if (GetOpenFileName(&ofn)==TRUE)
{
if(load()==0)
{
Right();Top();Front();
FrontSingle(RED_INDEX);
FrontWall(YELLOW_INDEX);
SwapBuffers(hDC);
CURSECT=0;
CURWALL=sector[CURSECT].wallptr;
}
else MessageBox(WindowFromDC(hDC), "Cannot open map!","Error While Loading",MB_OK);
}
// break;
// }
break;
//*/
case WM_PAINT:
// {
// PAINTSTRUCT ps;
BeginPaint(hWnd, &ps);
if (hGLRC) {
redraw();
}
EndPaint(hWnd, &ps);
return 0;
// }
// break;
// case WM_COMMAND:
// break;
// return 0L;
// default:
// break;
}
return DefWindowProc(hWnd, message, wParam, lParam);
}
int DoWMCommand(WPARAM wParam, HWND hWnd);
void DoLButtonDown(HWND hWnd, LONG lParam);
void DoLButtonUp(HWND hWnd, LONG lParam);
void DoMouseMove(HWND hWnd, LONG lParam);
void DoPaint(HWND hWnd);
void DrawShape(HDC hdc, int x, int y, int x2, int y2, int Shape,
int PenWidth, COLORREF PenColor, int Slope);
LRESULT CALLBACK WndProc2 (HWND, UINT, WPARAM, LPARAM);
// GLOBAL VARIABLES
#define ShapeI 100
#define STRICT
int ShapeNumber = -1; // Indicates the number of shapes drawn.
int CurrentShape = LINE; // The shape the user is drawing.
int PenWidth = 3; // The current pen width.
// Default width is medium.
COLORREF PenColor = RGB(255, 128, 128); // The current pen color.
// Default is red.
typedef struct SSHAPE // Struct which tracks the drawn shapes.
{
RECT Points; // Location of shape.
int PenWidth; // Pen width for the shape.
int Shape; // Type of shape.
COLORREF PenColor; // Color of shape.
int Slope; // Used to draw lines correctly.
} SHAPE;
SHAPE Shapes[ShapeI]; // Array that stores the shapes.
#pragma argsused
int APIENTRY
WinMain(
HINSTANCE hCurrentInst,
HINSTANCE hPreviousInst,
LPSTR lpszCmdLine,
int nCmdShow)
{
WNDCLASS wndClass;
WNDCLASS wndClass2;
// HWND hWnd;
MSG msg;
HINSTANCE hCurrentInst2=hCurrentInst;
_control87(MCW_EM, MCW_EM);
sprintf(szFile,"e1l1.map");
if(lpszCmdLine[0]!=0)
{
if(lpszCmdLine[0]=='-'||lpszCmdLine[0]=='/'||lpszCmdLine[0]=='?')
{
MessageBox(NULL,"openglbt.exe [filename]\nopens the map file called filename.","OpenGL Build Touch v1.9.1 - Command line help",MB_ICONINFORMATION|MB_OK);
exit(0);
}
else
sprintf(szFile,"%s",lpszCmdLine);
}
load();
classMenu=MAKEINTRESOURCE(OpenGLBT);
wndClass.style = CS_SAVEBITS|CS_BYTEALIGNCLIENT|CS_BYTEALIGNWINDOW;
wndClass.lpfnWndProc = (WNDPROC)WndProc;
wndClass.cbClsExtra = 0;
wndClass.cbWndExtra = 0;
wndClass.hInstance = hCurrentInst;
wndClass.hIcon = LoadIcon(hCurrentInst, MAKEINTRESOURCE(IDI_ICON1));
wndClass.hCursor = LoadCursor(NULL, IDC_ARROW);
wndClass.hbrBackground = GetStockObject(BLACK_BRUSH);
wndClass.lpszMenuName = classMenu;
wndClass.lpszClassName = className;
RegisterClass(&wndClass);
/* create window */
hWnd = CreateWindow(
className, windowName,
WS_SIZEBOX | WS_OVERLAPPEDWINDOW| WS_CLIPCHILDREN ,//| WS_CLIPCHILDREN | WS_CLIPSIBLINGS,
// 0, 0, maxX, maxY,
0, 0, 700, 700,
NULL, NULL, hCurrentInst, NULL);
//CreateMenu();
//hWnd2=CreateStatusWindow(WS_CLIPCHILDREN|WS_VISIBLE|WS_CHILD,"Text",hWnd,1000);
/* display window */
ShowWindow(hWnd, nCmdShow);
GetClientRect( hWnd, &rect );
// UpdateWindow(hWnd);
/* while (GetMessage(&msg, NULL, 0, 0) == TRUE) {
TranslateMessage(&msg);
DispatchMessage(&msg);
}
*/
while (1) {
while (PeekMessage(&msg, NULL, 0, 0, PM_NOREMOVE) == TRUE)
{
if (GetMessage(&msg, NULL, 0, 0) )
{
TranslateMessage(&msg);
DispatchMessage(&msg);
} else {
return TRUE;
}
}
// drawScene();
// redraw();
}
// return msg.wParam;
}
